'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-64113c20.js');
const store = require('./store-fe3d3434.js');
const sdkRedux = require('@boldpenguin/sdk-redux');
const isEqual = require('./isEqual-30f1b2bc.js');
const debounce = require('./debounce-5ee836a2.js');
const index_esm_min = require('./index.esm.min-d6127cb6.js');
const index_esm_min$1 = require('./index.esm.min-8bc5517a.js');
require('./_commonjsHelpers-bcc1208a.js');

const bpSdkAddQuestionPoolItemContainerCss = "";

const BpSdkAddQuestionPoolItemContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.handleSubscriptions = () => {
      if (store.canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        store.store.mapDispatchToProps(this, { addQuestionPool: sdkRedux.addQuestionPool });
        this.storeUnsubscribe = store.store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        applicationId: sdkRedux.getFormId(state),
        config: sdkRedux.getPartnerEngineConfig(state),
        questionSetState: sdkRedux.selectQuestionSetsState(state),
      };
    };
    this.questionId = undefined;
    this.helpText = '';
    this.questionSetId = undefined;
    this.text = '+';
    this.applicationId = undefined;
    this.config = undefined;
    this.questionSetState = undefined;
    this.useExternal = false;
    this.questionPool = undefined;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-add-question-pool-item-container');
    customElements.whenDefined('bp-sdk-external-add-question-pool-item-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
    this.onQuestionSetIdChange(this.questionSetId);
    this.onQuestionIdChange(this.questionId);
  }
  onQuestionSetIdChange(questionSetId) {
    this.updateQuestionPool(questionSetId, this.questionId, this.questionSetState);
  }
  onQuestionIdChange(questionId) {
    this.updateQuestionPool(this.questionSetId, questionId, this.questionSetState);
  }
  onQuestionSetsChange(questionSetState) {
    this.updateQuestionPool(this.questionSetId, this.questionId, questionSetState);
  }
  updateQuestionPool(questionSetId, questionId, questionSetState) {
    var _a, _b, _c;
    let set = (_a = questionSetState === null || questionSetState === void 0 ? void 0 : questionSetState.list) === null || _a === void 0 ? void 0 : _a.filter((set) => set.question_set_id === questionSetId)[0];
    const f = (questionSetState === null || questionSetState === void 0 ? void 0 : questionSetState.parentQuestionSets.length) > 0;
    if (f) {
      const hasParent = questionSetState.parentQuestionSets.find((qs) => qs.question_set_id === questionSetId);
      if (hasParent) {
        set = hasParent;
      }
    }
    const pools = (_c = (_b = set === null || set === void 0 ? void 0 : set.question_set) === null || _b === void 0 ? void 0 : _b.question_pools) !== null && _c !== void 0 ? _c : [];
    this.questionPool = pools.find((pool) => pool.parent_question_id === questionId);
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-add-question-pool-item-container", { applicationId: this.applicationId, config: this.config, helpText: this.helpText, questionId: this.questionId, questionSetId: this.questionSetId, questionSetState: this.questionSetState, text: this.text }));
  }
  renderInternal() {
    return (index.h("div", { class: "bp-sdk-add-question-pool-item-container__container" }, this.questionPool && (index.h("bp-sdk-question-pool-container", { addText: this.questionPool.add_text, code: this.questionPool.code, description: this.questionPool.description, displayText: this.questionPool.display_text, guid: this.questionPool.id, parentQuestionPoolId: this.questionPool.parent_question_pool_id, parentQuestionPoolReferenceId: this.questionPool.parent_question_pool_reference_id, ownerId: this.questionPool.owner_id, parentQuestionId: this.questionPool.parent_question_id, removeText: this.questionPool.remove_text, tenantId: this.questionPool.tenant_id, config: this.config, applicationId: this.applicationId }))));
  }
  get el() { return index.getElement(this); }
  static get watchers() { return {
    "questionSetId": ["onQuestionSetIdChange"],
    "questionId": ["onQuestionIdChange"],
    "questionSetState": ["onQuestionSetsChange"]
  }; }
};
BpSdkAddQuestionPoolItemContainer.style = bpSdkAddQuestionPoolItemContainerCss;

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG$1 = 1,
    COMPARE_UNORDERED_FLAG$1 = 2;

/**
 * The base implementation of `_.isMatch` without support for iteratee shorthands.
 *
 * @private
 * @param {Object} object The object to inspect.
 * @param {Object} source The object of property values to match.
 * @param {Array} matchData The property names, values, and compare flags to match.
 * @param {Function} [customizer] The function to customize comparisons.
 * @returns {boolean} Returns `true` if `object` is a match, else `false`.
 */
function baseIsMatch(object, source, matchData, customizer) {
  var index = matchData.length,
      length = index,
      noCustomizer = !customizer;

  if (object == null) {
    return !length;
  }
  object = Object(object);
  while (index--) {
    var data = matchData[index];
    if ((noCustomizer && data[2])
          ? data[1] !== object[data[0]]
          : !(data[0] in object)
        ) {
      return false;
    }
  }
  while (++index < length) {
    data = matchData[index];
    var key = data[0],
        objValue = object[key],
        srcValue = data[1];

    if (noCustomizer && data[2]) {
      if (objValue === undefined && !(key in object)) {
        return false;
      }
    } else {
      var stack = new isEqual._Stack;
      if (customizer) {
        var result = customizer(objValue, srcValue, key, object, source, stack);
      }
      if (!(result === undefined
            ? isEqual._baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG$1 | COMPARE_UNORDERED_FLAG$1, customizer, stack)
            : result
          )) {
        return false;
      }
    }
  }
  return true;
}

var _baseIsMatch = baseIsMatch;

/**
 * Checks if `value` is suitable for strict equality comparisons, i.e. `===`.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` if suitable for strict
 *  equality comparisons, else `false`.
 */
function isStrictComparable(value) {
  return value === value && !isEqual.isObject_1(value);
}

var _isStrictComparable = isStrictComparable;

/**
 * Gets the property names, values, and compare flags of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the match data of `object`.
 */
function getMatchData(object) {
  var result = isEqual.keys_1(object),
      length = result.length;

  while (length--) {
    var key = result[length],
        value = object[key];

    result[length] = [key, value, _isStrictComparable(value)];
  }
  return result;
}

var _getMatchData = getMatchData;

/**
 * A specialized version of `matchesProperty` for source values suitable
 * for strict equality comparisons, i.e. `===`.
 *
 * @private
 * @param {string} key The key of the property to get.
 * @param {*} srcValue The value to match.
 * @returns {Function} Returns the new spec function.
 */
function matchesStrictComparable(key, srcValue) {
  return function(object) {
    if (object == null) {
      return false;
    }
    return object[key] === srcValue &&
      (srcValue !== undefined || (key in Object(object)));
  };
}

var _matchesStrictComparable = matchesStrictComparable;

/**
 * The base implementation of `_.matches` which doesn't clone `source`.
 *
 * @private
 * @param {Object} source The object of property values to match.
 * @returns {Function} Returns the new spec function.
 */
function baseMatches(source) {
  var matchData = _getMatchData(source);
  if (matchData.length == 1 && matchData[0][2]) {
    return _matchesStrictComparable(matchData[0][0], matchData[0][1]);
  }
  return function(object) {
    return object === source || _baseIsMatch(object, source, matchData);
  };
}

var _baseMatches = baseMatches;

/** Used to match property names within property paths. */
var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,
    reIsPlainProp = /^\w*$/;

/**
 * Checks if `value` is a property name and not a property path.
 *
 * @private
 * @param {*} value The value to check.
 * @param {Object} [object] The object to query keys on.
 * @returns {boolean} Returns `true` if `value` is a property name, else `false`.
 */
function isKey(value, object) {
  if (isEqual.isArray_1(value)) {
    return false;
  }
  var type = typeof value;
  if (type == 'number' || type == 'symbol' || type == 'boolean' ||
      value == null || debounce.isSymbol_1(value)) {
    return true;
  }
  return reIsPlainProp.test(value) || !reIsDeepProp.test(value) ||
    (object != null && value in Object(object));
}

var _isKey = isKey;

/** Error message constants. */
var FUNC_ERROR_TEXT = 'Expected a function';

/**
 * Creates a function that memoizes the result of `func`. If `resolver` is
 * provided, it determines the cache key for storing the result based on the
 * arguments provided to the memoized function. By default, the first argument
 * provided to the memoized function is used as the map cache key. The `func`
 * is invoked with the `this` binding of the memoized function.
 *
 * **Note:** The cache is exposed as the `cache` property on the memoized
 * function. Its creation may be customized by replacing the `_.memoize.Cache`
 * constructor with one whose instances implement the
 * [`Map`](http://ecma-international.org/ecma-262/7.0/#sec-properties-of-the-map-prototype-object)
 * method interface of `clear`, `delete`, `get`, `has`, and `set`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Function
 * @param {Function} func The function to have its output memoized.
 * @param {Function} [resolver] The function to resolve the cache key.
 * @returns {Function} Returns the new memoized function.
 * @example
 *
 * var object = { 'a': 1, 'b': 2 };
 * var other = { 'c': 3, 'd': 4 };
 *
 * var values = _.memoize(_.values);
 * values(object);
 * // => [1, 2]
 *
 * values(other);
 * // => [3, 4]
 *
 * object.a = 2;
 * values(object);
 * // => [1, 2]
 *
 * // Modify the result cache.
 * values.cache.set(object, ['a', 'b']);
 * values(object);
 * // => ['a', 'b']
 *
 * // Replace `_.memoize.Cache`.
 * _.memoize.Cache = WeakMap;
 */
function memoize(func, resolver) {
  if (typeof func != 'function' || (resolver != null && typeof resolver != 'function')) {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  var memoized = function() {
    var args = arguments,
        key = resolver ? resolver.apply(this, args) : args[0],
        cache = memoized.cache;

    if (cache.has(key)) {
      return cache.get(key);
    }
    var result = func.apply(this, args);
    memoized.cache = cache.set(key, result) || cache;
    return result;
  };
  memoized.cache = new (memoize.Cache || isEqual._MapCache);
  return memoized;
}

// Expose `MapCache`.
memoize.Cache = isEqual._MapCache;

var memoize_1 = memoize;

/** Used as the maximum memoize cache size. */
var MAX_MEMOIZE_SIZE = 500;

/**
 * A specialized version of `_.memoize` which clears the memoized function's
 * cache when it exceeds `MAX_MEMOIZE_SIZE`.
 *
 * @private
 * @param {Function} func The function to have its output memoized.
 * @returns {Function} Returns the new memoized function.
 */
function memoizeCapped(func) {
  var result = memoize_1(func, function(key) {
    if (cache.size === MAX_MEMOIZE_SIZE) {
      cache.clear();
    }
    return key;
  });

  var cache = result.cache;
  return result;
}

var _memoizeCapped = memoizeCapped;

/** Used to match property names within property paths. */
var rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;

/** Used to match backslashes in property paths. */
var reEscapeChar = /\\(\\)?/g;

/**
 * Converts `string` to a property path array.
 *
 * @private
 * @param {string} string The string to convert.
 * @returns {Array} Returns the property path array.
 */
var stringToPath = _memoizeCapped(function(string) {
  var result = [];
  if (string.charCodeAt(0) === 46 /* . */) {
    result.push('');
  }
  string.replace(rePropName, function(match, number, quote, subString) {
    result.push(quote ? subString.replace(reEscapeChar, '$1') : (number || match));
  });
  return result;
});

var _stringToPath = stringToPath;

/**
 * A specialized version of `_.map` for arrays without support for iteratee
 * shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the new mapped array.
 */
function arrayMap(array, iteratee) {
  var index = -1,
      length = array == null ? 0 : array.length,
      result = Array(length);

  while (++index < length) {
    result[index] = iteratee(array[index], index, array);
  }
  return result;
}

var _arrayMap = arrayMap;

/** Used as references for various `Number` constants. */
var INFINITY$2 = 1 / 0;

/** Used to convert symbols to primitives and strings. */
var symbolProto = isEqual._Symbol ? isEqual._Symbol.prototype : undefined,
    symbolToString = symbolProto ? symbolProto.toString : undefined;

/**
 * The base implementation of `_.toString` which doesn't convert nullish
 * values to empty strings.
 *
 * @private
 * @param {*} value The value to process.
 * @returns {string} Returns the string.
 */
function baseToString(value) {
  // Exit early for strings to avoid a performance hit in some environments.
  if (typeof value == 'string') {
    return value;
  }
  if (isEqual.isArray_1(value)) {
    // Recursively convert values (susceptible to call stack limits).
    return _arrayMap(value, baseToString) + '';
  }
  if (debounce.isSymbol_1(value)) {
    return symbolToString ? symbolToString.call(value) : '';
  }
  var result = (value + '');
  return (result == '0' && (1 / value) == -INFINITY$2) ? '-0' : result;
}

var _baseToString = baseToString;

/**
 * Converts `value` to a string. An empty string is returned for `null`
 * and `undefined` values. The sign of `-0` is preserved.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to convert.
 * @returns {string} Returns the converted string.
 * @example
 *
 * _.toString(null);
 * // => ''
 *
 * _.toString(-0);
 * // => '-0'
 *
 * _.toString([1, 2, 3]);
 * // => '1,2,3'
 */
function toString(value) {
  return value == null ? '' : _baseToString(value);
}

var toString_1 = toString;

/**
 * Casts `value` to a path array if it's not one.
 *
 * @private
 * @param {*} value The value to inspect.
 * @param {Object} [object] The object to query keys on.
 * @returns {Array} Returns the cast property path array.
 */
function castPath(value, object) {
  if (isEqual.isArray_1(value)) {
    return value;
  }
  return _isKey(value, object) ? [value] : _stringToPath(toString_1(value));
}

var _castPath = castPath;

/** Used as references for various `Number` constants. */
var INFINITY$1 = 1 / 0;

/**
 * Converts `value` to a string key if it's not a string or symbol.
 *
 * @private
 * @param {*} value The value to inspect.
 * @returns {string|symbol} Returns the key.
 */
function toKey(value) {
  if (typeof value == 'string' || debounce.isSymbol_1(value)) {
    return value;
  }
  var result = (value + '');
  return (result == '0' && (1 / value) == -INFINITY$1) ? '-0' : result;
}

var _toKey = toKey;

/**
 * The base implementation of `_.get` without support for default values.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Array|string} path The path of the property to get.
 * @returns {*} Returns the resolved value.
 */
function baseGet(object, path) {
  path = _castPath(path, object);

  var index = 0,
      length = path.length;

  while (object != null && index < length) {
    object = object[_toKey(path[index++])];
  }
  return (index && index == length) ? object : undefined;
}

var _baseGet = baseGet;

/**
 * Gets the value at `path` of `object`. If the resolved value is
 * `undefined`, the `defaultValue` is returned in its place.
 *
 * @static
 * @memberOf _
 * @since 3.7.0
 * @category Object
 * @param {Object} object The object to query.
 * @param {Array|string} path The path of the property to get.
 * @param {*} [defaultValue] The value returned for `undefined` resolved values.
 * @returns {*} Returns the resolved value.
 * @example
 *
 * var object = { 'a': [{ 'b': { 'c': 3 } }] };
 *
 * _.get(object, 'a[0].b.c');
 * // => 3
 *
 * _.get(object, ['a', '0', 'b', 'c']);
 * // => 3
 *
 * _.get(object, 'a.b.c', 'default');
 * // => 'default'
 */
function get(object, path, defaultValue) {
  var result = object == null ? undefined : _baseGet(object, path);
  return result === undefined ? defaultValue : result;
}

var get_1 = get;

/**
 * The base implementation of `_.hasIn` without support for deep paths.
 *
 * @private
 * @param {Object} [object] The object to query.
 * @param {Array|string} key The key to check.
 * @returns {boolean} Returns `true` if `key` exists, else `false`.
 */
function baseHasIn(object, key) {
  return object != null && key in Object(object);
}

var _baseHasIn = baseHasIn;

/**
 * Checks if `path` exists on `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Array|string} path The path to check.
 * @param {Function} hasFunc The function to check properties.
 * @returns {boolean} Returns `true` if `path` exists, else `false`.
 */
function hasPath(object, path, hasFunc) {
  path = _castPath(path, object);

  var index = -1,
      length = path.length,
      result = false;

  while (++index < length) {
    var key = _toKey(path[index]);
    if (!(result = object != null && hasFunc(object, key))) {
      break;
    }
    object = object[key];
  }
  if (result || ++index != length) {
    return result;
  }
  length = object == null ? 0 : object.length;
  return !!length && isEqual.isLength_1(length) && isEqual._isIndex(key, length) &&
    (isEqual.isArray_1(object) || isEqual.isArguments_1(object));
}

var _hasPath = hasPath;

/**
 * Checks if `path` is a direct or inherited property of `object`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Object
 * @param {Object} object The object to query.
 * @param {Array|string} path The path to check.
 * @returns {boolean} Returns `true` if `path` exists, else `false`.
 * @example
 *
 * var object = _.create({ 'a': _.create({ 'b': 2 }) });
 *
 * _.hasIn(object, 'a');
 * // => true
 *
 * _.hasIn(object, 'a.b');
 * // => true
 *
 * _.hasIn(object, ['a', 'b']);
 * // => true
 *
 * _.hasIn(object, 'b');
 * // => false
 */
function hasIn(object, path) {
  return object != null && _hasPath(object, path, _baseHasIn);
}

var hasIn_1 = hasIn;

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1,
    COMPARE_UNORDERED_FLAG = 2;

/**
 * The base implementation of `_.matchesProperty` which doesn't clone `srcValue`.
 *
 * @private
 * @param {string} path The path of the property to get.
 * @param {*} srcValue The value to match.
 * @returns {Function} Returns the new spec function.
 */
function baseMatchesProperty(path, srcValue) {
  if (_isKey(path) && _isStrictComparable(srcValue)) {
    return _matchesStrictComparable(_toKey(path), srcValue);
  }
  return function(object) {
    var objValue = get_1(object, path);
    return (objValue === undefined && objValue === srcValue)
      ? hasIn_1(object, path)
      : isEqual._baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG);
  };
}

var _baseMatchesProperty = baseMatchesProperty;

/**
 * This method returns the first argument it receives.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Util
 * @param {*} value Any value.
 * @returns {*} Returns `value`.
 * @example
 *
 * var object = { 'a': 1 };
 *
 * console.log(_.identity(object) === object);
 * // => true
 */
function identity(value) {
  return value;
}

var identity_1 = identity;

/**
 * The base implementation of `_.property` without support for deep paths.
 *
 * @private
 * @param {string} key The key of the property to get.
 * @returns {Function} Returns the new accessor function.
 */
function baseProperty(key) {
  return function(object) {
    return object == null ? undefined : object[key];
  };
}

var _baseProperty = baseProperty;

/**
 * A specialized version of `baseProperty` which supports deep paths.
 *
 * @private
 * @param {Array|string} path The path of the property to get.
 * @returns {Function} Returns the new accessor function.
 */
function basePropertyDeep(path) {
  return function(object) {
    return _baseGet(object, path);
  };
}

var _basePropertyDeep = basePropertyDeep;

/**
 * Creates a function that returns the value at `path` of a given object.
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Util
 * @param {Array|string} path The path of the property to get.
 * @returns {Function} Returns the new accessor function.
 * @example
 *
 * var objects = [
 *   { 'a': { 'b': 2 } },
 *   { 'a': { 'b': 1 } }
 * ];
 *
 * _.map(objects, _.property('a.b'));
 * // => [2, 1]
 *
 * _.map(_.sortBy(objects, _.property(['a', 'b'])), 'a.b');
 * // => [1, 2]
 */
function property(path) {
  return _isKey(path) ? _baseProperty(_toKey(path)) : _basePropertyDeep(path);
}

var property_1 = property;

/**
 * The base implementation of `_.iteratee`.
 *
 * @private
 * @param {*} [value=_.identity] The value to convert to an iteratee.
 * @returns {Function} Returns the iteratee.
 */
function baseIteratee(value) {
  // Don't store the `typeof` result in a variable to avoid a JIT bug in Safari 9.
  // See https://bugs.webkit.org/show_bug.cgi?id=156034 for more details.
  if (typeof value == 'function') {
    return value;
  }
  if (value == null) {
    return identity_1;
  }
  if (typeof value == 'object') {
    return isEqual.isArray_1(value)
      ? _baseMatchesProperty(value[0], value[1])
      : _baseMatches(value);
  }
  return property_1(value);
}

var _baseIteratee = baseIteratee;

/**
 * The base implementation of `_.findIndex` and `_.findLastIndex` without
 * support for iteratee shorthands.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {Function} predicate The function invoked per iteration.
 * @param {number} fromIndex The index to search from.
 * @param {boolean} [fromRight] Specify iterating from right to left.
 * @returns {number} Returns the index of the matched value, else `-1`.
 */
function baseFindIndex(array, predicate, fromIndex, fromRight) {
  var length = array.length,
      index = fromIndex + (fromRight ? 1 : -1);

  while ((fromRight ? index-- : ++index < length)) {
    if (predicate(array[index], index, array)) {
      return index;
    }
  }
  return -1;
}

var _baseFindIndex = baseFindIndex;

/**
 * The base implementation of `_.isNaN` without support for number objects.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is `NaN`, else `false`.
 */
function baseIsNaN(value) {
  return value !== value;
}

var _baseIsNaN = baseIsNaN;

/**
 * A specialized version of `_.indexOf` which performs strict equality
 * comparisons of values, i.e. `===`.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {*} value The value to search for.
 * @param {number} fromIndex The index to search from.
 * @returns {number} Returns the index of the matched value, else `-1`.
 */
function strictIndexOf(array, value, fromIndex) {
  var index = fromIndex - 1,
      length = array.length;

  while (++index < length) {
    if (array[index] === value) {
      return index;
    }
  }
  return -1;
}

var _strictIndexOf = strictIndexOf;

/**
 * The base implementation of `_.indexOf` without `fromIndex` bounds checks.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {*} value The value to search for.
 * @param {number} fromIndex The index to search from.
 * @returns {number} Returns the index of the matched value, else `-1`.
 */
function baseIndexOf(array, value, fromIndex) {
  return value === value
    ? _strictIndexOf(array, value, fromIndex)
    : _baseFindIndex(array, _baseIsNaN, fromIndex);
}

var _baseIndexOf = baseIndexOf;

/**
 * A specialized version of `_.includes` for arrays without support for
 * specifying an index to search from.
 *
 * @private
 * @param {Array} [array] The array to inspect.
 * @param {*} target The value to search for.
 * @returns {boolean} Returns `true` if `target` is found, else `false`.
 */
function arrayIncludes(array, value) {
  var length = array == null ? 0 : array.length;
  return !!length && _baseIndexOf(array, value, 0) > -1;
}

var _arrayIncludes = arrayIncludes;

/**
 * This function is like `arrayIncludes` except that it accepts a comparator.
 *
 * @private
 * @param {Array} [array] The array to inspect.
 * @param {*} target The value to search for.
 * @param {Function} comparator The comparator invoked per element.
 * @returns {boolean} Returns `true` if `target` is found, else `false`.
 */
function arrayIncludesWith(array, value, comparator) {
  var index = -1,
      length = array == null ? 0 : array.length;

  while (++index < length) {
    if (comparator(value, array[index])) {
      return true;
    }
  }
  return false;
}

var _arrayIncludesWith = arrayIncludesWith;

/**
 * This method returns `undefined`.
 *
 * @static
 * @memberOf _
 * @since 2.3.0
 * @category Util
 * @example
 *
 * _.times(2, _.noop);
 * // => [undefined, undefined]
 */
function noop() {
  // No operation performed.
}

var noop_1 = noop;

/** Used as references for various `Number` constants. */
var INFINITY = 1 / 0;

/**
 * Creates a set object of `values`.
 *
 * @private
 * @param {Array} values The values to add to the set.
 * @returns {Object} Returns the new set.
 */
var createSet = !(isEqual._Set && (1 / isEqual._setToArray(new isEqual._Set([,-0]))[1]) == INFINITY) ? noop_1 : function(values) {
  return new isEqual._Set(values);
};

var _createSet = createSet;

/** Used as the size to enable large array optimizations. */
var LARGE_ARRAY_SIZE$1 = 200;

/**
 * The base implementation of `_.uniqBy` without support for iteratee shorthands.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {Function} [iteratee] The iteratee invoked per element.
 * @param {Function} [comparator] The comparator invoked per element.
 * @returns {Array} Returns the new duplicate free array.
 */
function baseUniq(array, iteratee, comparator) {
  var index = -1,
      includes = _arrayIncludes,
      length = array.length,
      isCommon = true,
      result = [],
      seen = result;

  if (comparator) {
    isCommon = false;
    includes = _arrayIncludesWith;
  }
  else if (length >= LARGE_ARRAY_SIZE$1) {
    var set = iteratee ? null : _createSet(array);
    if (set) {
      return isEqual._setToArray(set);
    }
    isCommon = false;
    includes = isEqual._cacheHas;
    seen = new isEqual._SetCache;
  }
  else {
    seen = iteratee ? [] : result;
  }
  outer:
  while (++index < length) {
    var value = array[index],
        computed = iteratee ? iteratee(value) : value;

    value = (comparator || value !== 0) ? value : 0;
    if (isCommon && computed === computed) {
      var seenIndex = seen.length;
      while (seenIndex--) {
        if (seen[seenIndex] === computed) {
          continue outer;
        }
      }
      if (iteratee) {
        seen.push(computed);
      }
      result.push(value);
    }
    else if (!includes(seen, computed, comparator)) {
      if (seen !== result) {
        seen.push(computed);
      }
      result.push(value);
    }
  }
  return result;
}

var _baseUniq = baseUniq;

/**
 * This method is like `_.uniq` except that it accepts `iteratee` which is
 * invoked for each element in `array` to generate the criterion by which
 * uniqueness is computed. The order of result values is determined by the
 * order they occur in the array. The iteratee is invoked with one argument:
 * (value).
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Array
 * @param {Array} array The array to inspect.
 * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
 * @returns {Array} Returns the new duplicate free array.
 * @example
 *
 * _.uniqBy([2.1, 1.2, 2.3], Math.floor);
 * // => [2.1, 1.2]
 *
 * // The `_.property` iteratee shorthand.
 * _.uniqBy([{ 'x': 1 }, { 'x': 2 }, { 'x': 1 }], 'x');
 * // => [{ 'x': 1 }, { 'x': 2 }]
 */
function uniqBy(array, iteratee) {
  return (array && array.length) ? _baseUniq(array, _baseIteratee(iteratee)) : [];
}

var uniqBy_1 = uniqBy;

const bpSdkAutocompleteNaicsContainerCss = "";

const BpSdkAutocompleteNaicsContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.handleSubscriptions = () => {
      if (store.canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        store.store.mapDispatchToProps(this, { searchChoices: sdkRedux.searchChoices });
        this.storeUnsubscribe = store.store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        remoteChoices: sdkRedux.getSelectedChoices(state, this.questionId),
        config: sdkRedux.getPartnerEngineConfig(state),
      };
    };
    this.answerId = undefined;
    this.questionId = undefined;
    this.placeholder = '';
    this.required = false;
    this.code = undefined;
    this.errors = undefined;
    this.errorText = undefined;
    this.labelId = undefined;
    this.choiceId = undefined;
    this.choices = [];
    this.touched = false;
    this.pristine = true;
    this.isCompleted = false;
    this.isReadOnly = false;
    this.fieldType = undefined;
    this.label = undefined;
    this.labelledBy = undefined;
    this.remoteChoices = [];
    this.config = undefined;
    this.helpText = undefined;
    this.answeredBySource = undefined;
    this.choiceMap = {};
    this.composedChoices = undefined;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-autocomplete-naics-container');
    customElements.whenDefined('bp-sdk-external-autocomplete-naics-container').then(() => {
      this.useExternal = true;
    });
    this.onQuestionIdChange();
    this.onChoicesChange(this.choices || []);
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  onQuestionIdChange() {
    this.handleSubscriptions();
  }
  onChoicesChange(choices) {
    this.choiceMap = choices.reduce((acc, choice) => (Object.assign(Object.assign({}, acc), { [choice.id]: [choice] })), {});
  }
  onChoicesUpdate(choices) {
    this.updateComposedChoices(choices, this.choiceMap);
  }
  onChoiceMapUpdate(choiceMap) {
    this.updateComposedChoices(this.remoteChoices, choiceMap);
  }
  updateComposedChoices(searchChoices, choiceMap) {
    var _a;
    const answerChoices = (_a = (choiceMap && choiceMap[this.choiceId])) !== null && _a !== void 0 ? _a : [];
    this.composedChoices = uniqBy_1([...searchChoices, ...answerChoices], (item) => item.id);
  }
  onFilterUpdate({ detail }) {
    if (this.useExternal) {
      return;
    }
    const params = {
      questionId: this.questionId,
      filter: detail.value,
      timestamp: Date.now(),
      config: this.config,
    };
    this.searchChoices(params);
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-autocomplete-naics-container", { "answer-id": this.answerId, choice_id: this.choiceId, choices: this.choices, code: this.code, config: this.config, errors: this.errors, error_text: this.errorText, field_type: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, is_completed: this.isCompleted, isReadOnly: this.isReadOnly, "label-id": this.labelId, label: this.label, "labelled-by": this.labelledBy, placeholder: this.placeholder, pristine: this.pristine, question_id: this.questionId, remoteChoices: this.remoteChoices, required: this.required, touched: this.touched }));
  }
  renderInternal() {
    return (index.h("div", { class: "bp-sdk-autocomplete-naics-container__container" }, index.h("bp-sdk-autocomplete-input", { answeredBySource: this.answeredBySource, answerId: this.answerId, choiceId: this.choiceId, choices: this.composedChoices, code: this.code, errors: this.errors, errorText: this.errorText, helpText: this.helpText, fieldType: this.fieldType, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, required: this.required, touched: this.touched })));
  }
  get el() { return index.getElement(this); }
  static get watchers() { return {
    "questionId": ["onQuestionIdChange"],
    "choices": ["onChoicesChange"],
    "remoteChoices": ["onChoicesUpdate"],
    "choiceMap": ["onChoiceMapUpdate"]
  }; }
};
BpSdkAutocompleteNaicsContainer.style = bpSdkAutocompleteNaicsContainerCss;

/** `Object#toString` result references. */
var mapTag = '[object Map]',
    setTag = '[object Set]';

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Checks if `value` is an empty object, collection, map, or set.
 *
 * Objects are considered empty if they have no own enumerable string keyed
 * properties.
 *
 * Array-like values such as `arguments` objects, arrays, buffers, strings, or
 * jQuery-like collections are considered empty if they have a `length` of `0`.
 * Similarly, maps and sets are considered empty if they have a `size` of `0`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is empty, else `false`.
 * @example
 *
 * _.isEmpty(null);
 * // => true
 *
 * _.isEmpty(true);
 * // => true
 *
 * _.isEmpty(1);
 * // => true
 *
 * _.isEmpty([1, 2, 3]);
 * // => false
 *
 * _.isEmpty({ 'a': 1 });
 * // => false
 */
function isEmpty(value) {
  if (value == null) {
    return true;
  }
  if (isEqual.isArrayLike_1(value) &&
      (isEqual.isArray_1(value) || typeof value == 'string' || typeof value.splice == 'function' ||
        isEqual.isBuffer_1(value) || isEqual.isTypedArray_1(value) || isEqual.isArguments_1(value))) {
    return !value.length;
  }
  var tag = isEqual._getTag(value);
  if (tag == mapTag || tag == setTag) {
    return !value.size;
  }
  if (isEqual._isPrototype(value)) {
    return !isEqual._baseKeys(value).length;
  }
  for (var key in value) {
    if (hasOwnProperty.call(value, key)) {
      return false;
    }
  }
  return true;
}

var isEmpty_1 = isEmpty;

const bpSdkBusinessClassificationSelectorContainerCss = "";

const BpSdkBusinessClassificationSelectorContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.handleSubscriptions = () => {
      if (store.canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        store.store.mapDispatchToProps(this, { searchChoices: sdkRedux.searchChoices, removeActiveAnswerId: sdkRedux.removeActiveAnswerId, searchChoicesWithNudges: sdkRedux.searchChoicesWithNudges });
        this.storeUnsubscribe = store.store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        showNaicsCode: state.viewState.features.list.includes('bcs_show_naics_code'),
        showConfidence: state.viewState.features.list.includes('bcs_show_naics_level'),
        remoteChoices: sdkRedux.getSelectedChoices(state, this.questionId),
        config: sdkRedux.getPartnerEngineConfig(state),
        isRefilteringEnabled: sdkRedux.isFeatureEnabled(state, 'bcs_refilter'),
      };
    };
    this.answerId = undefined;
    this.questionId = undefined;
    this.code = '';
    this.placeholder = '';
    this.required = false;
    this.errors = undefined;
    this.errorText = undefined;
    this.labelId = undefined;
    this.choiceId = undefined;
    this.touched = false;
    this.pristine = true;
    this.isCompleted = false;
    this.isReadOnly = false;
    this.fieldType = undefined;
    this.label = undefined;
    this.labelledBy = undefined;
    this.choices = [];
    this.remoteChoices = [];
    this.showNaicsCode = undefined;
    this.showConfidence = undefined;
    this.config = undefined;
    this.isRefilteringEnabled = false;
    this.helpText = undefined;
    this.answeredBySource = undefined;
    this.choiceMap = {};
    this._selectedChoices = [];
    this._searchChoices = [];
    this._currentSearchValue = '';
    this.useExternal = false;
    this.showChoices = false;
    this._refilterAnswers = {};
  }
  resetState() {
    this.showChoices = false;
    this._currentSearchValue = '';
  }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-business-classification-selector-container');
    customElements.whenDefined('bp-sdk-external-business-classification-selector-container').then(() => {
      this.useExternal = true;
    });
    this.onQuestionIdChange();
    this.onChoicesChange(this.choices || []);
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  onQuestionIdChange() {
    this.handleSubscriptions();
  }
  doSearchChoices() {
    if (this.useExternal) {
      return;
    }
    const params = {
      config: this.config,
      filter: this._currentSearchValue,
      questionId: this.questionId,
      timestamp: Date.now(),
      refilter: null,
    };
    if (this.isRefilteringEnabled) {
      if (!isEmpty_1(this._refilterAnswers)) {
        params.refilter = JSON.stringify(this._refilterAnswers);
      }
      this.searchChoicesWithNudges(params);
    }
    else {
      this.searchChoices(params);
    }
  }
  onFilterUpdate({ detail }) {
    if (this.useExternal) {
      return;
    }
    this.showChoices = true;
    this._currentSearchValue = detail.value;
    this._refilterAnswers = {};
    this.doSearchChoices();
  }
  onRefilterAnswer({ detail }) {
    // Add nudge answer to local state, it gets used in doSearchChoices
    this._refilterAnswers[detail.key] = detail.answer ? 'Y' : 'N';
    this.doSearchChoices();
  }
  onValueUpdate() {
    if (this.useExternal) {
      return;
    }
    this.showChoices = false;
    this.removeActiveAnswerId();
  }
  onChoicesChange(choices) {
    this.choiceMap = choices.reduce((acc, choice) => (Object.assign(Object.assign({}, acc), { [choice.id]: [choice] })), {});
  }
  onChoicesUpdate(choices) {
    this.updateComposedChoices(choices, this.choiceMap);
  }
  onChoiceMapUpdate(choiceMap) {
    this.updateComposedChoices(this.remoteChoices, choiceMap);
  }
  updateComposedChoices(searchChoices, choiceMap) {
    this._selectedChoices = choiceMap && choiceMap[this.choiceId] ? choiceMap[this.choiceId] : [];
    this._searchChoices = searchChoices;
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-business-classification-selector-container", { answerId: this.answerId, choiceId: this.choiceId, choices: this.choices, code: this.code, config: this.config, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, labelId: this.labelId, label: this.label, labelledBy: this.labelledBy, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, remoteChoices: this.remoteChoices, required: this.required, touched: this.touched, showConfidence: this.showConfidence, showNaicsCode: this.showNaicsCode, selectedChoices: this._selectedChoices, isRefilteringEnabled: this.isRefilteringEnabled }));
  }
  renderInternal() {
    return [
      index.h("bp-sdk-business-classification-selector", { answerId: this.answerId, choiceId: this.choiceId, choices: this._searchChoices, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, required: this.required, touched: this.touched, showChoices: this.showChoices, showConfidence: this.showConfidence, showNaicsCode: this.showNaicsCode, selectedChoices: this._selectedChoices, isRefilteringEnabled: this.isRefilteringEnabled }),
    ];
  }
  get el() { return index.getElement(this); }
  static get watchers() { return {
    "questionId": ["onQuestionIdChange"],
    "choices": ["onChoicesChange"],
    "remoteChoices": ["onChoicesUpdate"],
    "choiceMap": ["onChoiceMapUpdate"]
  }; }
};
BpSdkBusinessClassificationSelectorContainer.style = bpSdkBusinessClassificationSelectorContainerCss;

const bpSdkCheckboxInputCss = ".bp-sdk-checkbox__label:not(.read-only),.bp-sdk-checkbox__input{cursor:pointer}";

const BpSdkCheckboxInput = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.valueUpdate = index.createEvent(this, "valueUpdate", 7);
    this.onChange = (ev) => {
      const checked = ev.target.checked;
      this.valueUpdate.emit(checked);
    };
    this.answerId = undefined;
    this.questionId = undefined;
    this.fieldType = undefined;
    this.errors = undefined;
    this.errorText = undefined;
    this.code = undefined;
    this.value = undefined;
    this.label = undefined;
    this.labelledBy = undefined;
    this.required = undefined;
    this.touched = false;
    this.pristine = true;
    this.isCompleted = false;
    this.isReadOnly = false;
    this.helpText = undefined;
    this.answeredBySource = undefined;
    this.id = undefined;
    this.useExternal = false;
  }
  onCodeChange(code) {
    this.updateId(code, this.answerId);
  }
  onAnswerIdChange(answerId) {
    this.updateId(this.code, answerId);
  }
  updateId(code, answerId) {
    this.id = `bp-sdk-checkbox-${code}-${answerId}-input`;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-checkbox-input');
    customElements.whenDefined('bp-sdk-external-checkbox-input').then(() => {
      this.useExternal = true;
    });
    this.onCodeChange(this.code);
    this.onAnswerIdChange(this.answerId);
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-checkbox-input", { answeredBySource: this.answeredBySource, answerId: this.answerId, code: this.code, errorText: this.errorText, errors: this.errors, fieldType: this.fieldType, helpText: this.helpText, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelledBy: this.labelledBy, pristine: this.pristine, questionId: this.questionId, required: this.required, touched: this.touched, value: this.value }));
  }
  renderInternal() {
    var _a;
    return (index.h("div", { class: "bp-sdk-checkbox__container" }, index.h("div", { class: "bp-sdk-checkbox__wrapper" }, !this.isReadOnly && (index.h("input", { id: this.id, class: "bp-sdk-checkbox__input", type: "checkbox", "aria-labelledby": this.labelledBy, name: this.code, checked: !!this.value, onChange: this.onChange })), index.h("label", { htmlFor: this.id, class: {
        'bp-sdk-checkbox__label': true,
        'read-only': this.isReadOnly,
      } }, this.label), this.isReadOnly && this.renderReadOnlyElement(this.value ? 'Yes' : 'No')), this.touched && !this.pristine && ((this.errorText && !this.isCompleted) || !!((_a = this.errors) === null || _a === void 0 ? void 0 : _a.length)) && (index.h("bp-sdk-errors-container", { answerId: this.answerId, questionId: this.questionId, fieldType: this.fieldType, errors: this.errors, errorText: this.errorText }))));
  }
  renderReadOnlyElement(value) {
    return index.h("span", { class: "read-only-value" }, value);
  }
  static get watchers() { return {
    "code": ["onCodeChange"],
    "answerId": ["onAnswerIdChange"]
  }; }
};
BpSdkCheckboxInput.style = bpSdkCheckboxInputCss;

const bpSdkDateInputContainerCss = "";

const BpSdkDateInputContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.valueUpdate = index.createEvent(this, "valueUpdate", 7);
    this.answerId = undefined;
    this.questionId = undefined;
    this.fieldType = undefined;
    this.text = undefined;
    this.minDate = undefined;
    this.maxDate = undefined;
    this.code = undefined;
    this.value = undefined;
    this.placeholder = 'Pick a date';
    this.labelId = undefined;
    this.pattern = undefined;
    this.touched = false;
    this.pristine = true;
    this.isCompleted = false;
    this.isReadOnly = false;
    this.errors = [];
    this.errorText = undefined;
    this.isSensitive = false;
    this.label = undefined;
    this.labelledBy = undefined;
    this.required = undefined;
    this.helpText = undefined;
    this.answeredBySource = undefined;
    this._value = undefined;
    this.useExternal = false;
  }
  resetState() {
    this._value = undefined;
  }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-date-input-container');
    customElements.whenDefined('bp-sdk-external-date-input-container').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-date-input-container", { answerId: this.answerId, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, isSensitive: this.isSensitive, labelId: this.labelId, label: this.label, labelledBy: this.labelledBy, maxDate: this.maxDate, minDate: this.minDate, pattern: this.pattern, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, required: this.required, text: this.text, touched: this.touched, value: this.value }));
  }
  renderInternal() {
    return (index.h("bp-sdk-date-input", { answerId: this.answerId, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, isSensitive: this.isSensitive, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, maxDate: this.maxDate, minDate: this.minDate, pattern: this.pattern, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, required: this.required, text: this.text, touched: this.touched, value: this.value }));
  }
  get el() { return index.getElement(this); }
};
BpSdkDateInputContainer.style = bpSdkDateInputContainerCss;

const bpSdkDeleteQuestionPoolItemContainerCss = "";

const BpSdkDeleteQuestionPoolItemContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.handleSubscriptions = () => {
      if (store.canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        store.store.mapDispatchToProps(this, { removeQuestionPool: sdkRedux.removeQuestionPool });
        this.storeUnsubscribe = store.store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        applicationId: sdkRedux.getFormId(state),
        config: sdkRedux.getPartnerEngineConfig(state),
      };
    };
    this.handleRemoveItem = () => {
      this.removeQuestionPool({
        answer_pool_id: this.answerPoolId,
        application_id: this.applicationId,
        config: this.config,
      });
    };
    this.text = '';
    this.answerPoolId = undefined;
    this.applicationId = undefined;
    this.config = undefined;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-delete-question-pool-item-container');
    customElements.whenDefined('bp-sdk-external-delete-question-pool-item-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-delete-question-pool-item-container", { applicationId: this.applicationId, answerPoolId: this.answerPoolId, config: this.config, text: this.text }));
  }
  renderInternal() {
    return (index.h("div", { class: "bp-sdk-delete-question-pool-item-container__container" }, index.h("bp-sdk-delete-question-pool-item", { text: this.text, handleRemoveItem: this.handleRemoveItem })));
  }
  get el() { return index.getElement(this); }
};
BpSdkDeleteQuestionPoolItemContainer.style = bpSdkDeleteQuestionPoolItemContainerCss;

const bpSdkDriverInputContainerCss = "";

const BpSdkDriverInputContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.fakeValueUpdate = index.createEvent(this, "fakeValueUpdate", 7);
    this.mapStateToProps = (state) => {
      return {
        driverLicenseStateAnswer: sdkRedux.findActiveAnswersByGroup(state, {
          poolId: this.questionPoolId,
          groupId: this.questionGroupId,
        }).find((answer) => answer.question.reference_type === index_esm_min.p.DriversLicenseState),
      };
    };
    this.answerId = undefined;
    this.questionId = undefined;
    this.questionGroupId = undefined;
    this.questionPoolId = undefined;
    this.text = undefined;
    this.labelId = undefined;
    this.fieldType = 'text';
    this.placeholder = '';
    this.pattern = undefined;
    this.code = undefined;
    this.required = false;
    this.min = -1;
    this.max = -1;
    this.errors = [];
    this.errorText = undefined;
    this.touched = false;
    this.pristine = true;
    this.isCompleted = false;
    this.isReadOnly = false;
    this.label = undefined;
    this.labelledBy = undefined;
    this.isEnabled = true;
    this.referenceType = undefined;
    this.driverLicenseStateAnswer = undefined;
    this.helpText = undefined;
    this.useExternal = false;
    this.licenseError = undefined;
  }
  resetState() {
    this.licenseError = undefined;
  }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-driver-input-container');
    customElements.whenDefined('bp-sdk-external-driver-input-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
  }
  handleSubscriptions() {
    if (store.canGetStore()) {
      this.storeUnsubscribe && this.storeUnsubscribe();
      this.storeUnsubscribe = store.store.mapStateToProps(this, this.mapStateToProps);
    }
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  onSaveAnswer(e) {
    var _a, _b;
    if (this.useExternal) {
      return;
    }
    const state = (_b = (_a = this.driverLicenseStateAnswer) === null || _a === void 0 ? void 0 : _a.question.choices.find((choice) => choice.id === this.driverLicenseStateAnswer.choice_id)) === null || _b === void 0 ? void 0 : _b.alias;
    const detail = e.detail;
    this.licenseError =
      !state || !detail || index_esm_min$1.hf(detail, state) ? undefined : BpSdkDriverInputContainer.ERROR_MESSAGE;
    if (this.licenseError) {
      e.stopPropagation();
      this.fakeValueUpdate.emit();
    }
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-driver-input-container", { answerId: this.answerId, code: this.code, driverLicenseStateAnswer: this.driverLicenseStateAnswer, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, isCompleted: this.isCompleted, isEnabled: this.isEnabled, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, max: this.max, min: this.min, pattern: this.pattern, placeholder: this.placeholder, pristine: this.pristine, questionGroupId: this.questionGroupId, questionId: this.questionId, questionPoolId: this.questionPoolId, referenceType: this.referenceType, required: this.required, text: this.text, touched: this.touched }));
  }
  renderInternal() {
    var _a;
    return (index.h("bp-sdk-text-input-container", { answerId: this.answerId, code: this.code, errors: this.errors, errorText: (_a = this.licenseError) !== null && _a !== void 0 ? _a : this.errorText, fieldType: this.fieldType, helpText: this.helpText,
      // TODO: remove this if isCompleted is updated for this validation condition
      isCompleted: !this.licenseError && this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, max: this.max, min: this.min, pattern: this.pattern, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, referenceType: this.referenceType, required: this.required, text: this.text, touched: this.touched }));
  }
  static get watchers() { return {
    "questionGroupId": ["handleSubscriptions"],
    "questionPoolId": ["handleSubscriptions"]
  }; }
};
BpSdkDriverInputContainer.ERROR_MESSAGE = `Driver's license is invalid for state`;
BpSdkDriverInputContainer.style = bpSdkDriverInputContainerCss;

const bpSdkDynamicInputCss = "";

const BpSdkDynamicInput = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.componentMissing = index.createEvent(this, "componentMissing", 7);
    this.answerId = undefined;
    this.answerPoolId = undefined;
    this.applicationFormId = undefined;
    this.choiceId = undefined;
    this.choiceIds = [];
    this.choices = undefined;
    this.code = undefined;
    this.displayType = undefined;
    this.errors = undefined;
    this.errorText = undefined;
    this.fieldType = undefined;
    this.helpText = undefined;
    this.inputComponentType = undefined;
    this.isAutocomplete = undefined;
    this.isCompleted = undefined;
    this.isCoverageType = true;
    this.isHidden = undefined;
    this.isLabelledField = false;
    this.isMultiple = undefined;
    this.isReadOnly = false;
    this.isRequired = undefined;
    this.isSensitive = undefined;
    this.isTrackable = undefined;
    this.label = undefined;
    this.labelId = 'a11y-';
    this.labelledBy = undefined;
    this.maxDate = undefined;
    this.maxValue = undefined;
    this.minDate = undefined;
    this.minValue = undefined;
    this.order = undefined;
    this.pattern = undefined;
    this.placeholder = undefined;
    this.pristine = true;
    this.questionId = undefined;
    this.questionGroupId = undefined;
    this.questionSetId = undefined;
    this.referenceType = undefined;
    this.showBusinessClassificationSelector = false;
    this.shouldShowInput = true;
    this.touched = false;
    this.text = undefined;
    this.useSelectAlias = false;
    this.value = undefined;
    this.answeredBySource = undefined;
    this.id = index_esm_min$1.fx(10);
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-dynamic-input');
    customElements.whenDefined('bp-sdk-external-dynamic-input').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-dynamic-input", { answerId: this.answerId, answerPoolId: this.answerPoolId, applicationFormId: this.applicationFormId, choiceId: this.choiceId, choiceIds: this.choiceIds, choices: this.choices, code: this.code, displayType: this.displayType, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, inputComponentType: this.inputComponentType, isAutocomplete: this.isAutocomplete, isCompleted: this.isCompleted, isCoverageType: this.isCoverageType, isHidden: this.isHidden, isLabelledField: this.isLabelledField, isMultiple: this.isMultiple, isReadOnly: this.isReadOnly, isRequired: this.isRequired, isSensitive: this.isSensitive, isTrackable: this.isTrackable, labelId: this.labelId, label: this.label, labelledBy: this.labelledBy, maxDate: this.maxDate, maxValue: this.maxValue, minDate: this.minDate, minValue: this.minValue, order: this.order, pattern: this.pattern, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, questionGroupId: this.questionGroupId, questionSetId: this.questionSetId, referenceType: this.referenceType, showBusinessClassificationSelector: this.showBusinessClassificationSelector, shouldShowInput: this.shouldShowInput, text: this.text, touched: this.touched, useSelectAlias: this.useSelectAlias, value: this.value }));
  }
  renderInternal() {
    return (this.shouldShowInput && (index.h("div", { id: this.id, class: index_esm_min$1.ix('bp-sdk-dynamic__container', {
        'bp-sdk-dynamic_container--labeled': this.isLabelledField,
      }) }, this.fieldType !== index_esm_min.t.Label && this.renderQuestion(), this.fieldType === index_esm_min.t.Label && index.h("bp-sdk-label", { helpText: this.helpText, label: this.text }))));
  }
  renderQuestion() {
    const content = this.renderContent();
    if (!content) {
      this.componentMissing.emit(`Missing question type: ${this.fieldType} - ${this.code}`);
    }
    else {
      return content;
    }
  }
  renderContent() {
    switch (this.inputComponentType) {
      case index_esm_min.t.Text:
        return this.renderTextSwitch();
      case index_esm_min.t.VIN:
        return this.renderText();
      case index_esm_min.t.Masked:
        return this.renderMaskedInput();
      case index_esm_min.t.Date:
        return this.renderDate();
      case index_esm_min.t.DropDown:
        return this.renderDropdownSwitch();
      case index_esm_min.t.Dialog:
        return this.renderDialog();
      case index_esm_min.t.DriversLicense:
        return this.renderDriverLicense();
      case index_esm_min.t.CheckBox:
        return this.renderCheckbox();
      case index_esm_min.t.Radio:
        return this.renderRadio();
      case index_esm_min.t.CoverageType:
        return this.renderCoverageSelector();
      case index_esm_min.t.Anchor || index_esm_min.t.Step:
        return this.renderQuestionPoolItemContainer();
      case index_esm_min.t.DeletePool:
        return this.renderDeletePool();
      case index_esm_min.t.Vehicle:
        return this.renderVehicleAutocomplete();
    }
  }
  renderTextSwitch() {
    switch (this.referenceType) {
      case index_esm_min.p.Street1:
        return this.renderGooglePlacesAutocomplete();
      case index_esm_min.p.Increment:
        return this.renderIncrement();
      default:
        return this.renderText();
    }
  }
  renderGooglePlacesAutocomplete() {
    return (index.h("bp-sdk-google-places-autocomplete-container", { answeredBySource: this.answeredBySource, answerId: this.answerId, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, filter: this.value, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, max: this.maxValue, min: this.minValue, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, referenceType: this.referenceType, required: this.isRequired, touched: this.touched }));
  }
  renderDriverLicense() {
    return (index.h("bp-sdk-driver-input-container", { answerId: this.answerId, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, max: this.maxValue, min: this.minValue, pattern: this.pattern, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, questionGroupId: this.questionGroupId, questionPoolId: this.answerPoolId, referenceType: this.referenceType, required: this.isRequired, text: this.value, touched: this.touched }));
  }
  renderIncrement() {
    return (index.h("bp-sdk-increment-input", { answerId: this.answerId, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, max: this.maxValue, min: this.minValue, pattern: this.pattern, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, referenceType: this.referenceType, required: this.isRequired, text: this.value, touched: this.touched }));
  }
  renderText() {
    return (index.h("bp-sdk-text-input-container", { answerId: this.answerId, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, max: this.maxValue, min: this.minValue, pattern: this.pattern, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, referenceType: this.referenceType, required: this.isRequired, text: this.value, touched: this.touched }));
  }
  renderMaskedInput() {
    return (index.h("bp-sdk-masked-input-container", { answerId: this.answerId, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, max: this.maxValue, maxDate: this.maxDate, min: this.minValue, minDate: this.minDate, pattern: this.pattern, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, referenceType: this.referenceType, required: this.isRequired, touched: this.touched, value: this.value }));
  }
  renderDate() {
    if (this.isSensitive) {
      return this.renderMaskedInput();
    }
    else {
      return (index.h("bp-sdk-date-input-container", { answerId: this.answerId, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, isSensitive: this.isSensitive, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, maxDate: this.maxDate, minDate: this.minDate, placeholder: this.placeholder, pattern: this.pattern, pristine: this.pristine, questionId: this.questionId, required: this.isRequired, text: this.text, touched: this.touched, value: this.value }));
    }
  }
  renderDropdownSwitch() {
    switch (this.referenceType) {
      case index_esm_min.p.LinesOfBusiness:
        return this.renderCoverageSelector();
      default: {
        return this.renderDropdownFallback();
      }
    }
  }
  renderDropdownFallback() {
    if (this.isAutocomplete) {
      return this.renderBcsSwitch();
    }
    else {
      return this.renderSelect();
    }
  }
  renderSelect() {
    return (index.h("bp-sdk-select-input-container", { answerId: this.answerId, choiceId: this.choiceId, choiceIds: this.choiceIds, choices: this.choices, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, multiple: this.isMultiple, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, referenceType: this.referenceType, required: this.isRequired, touched: this.touched, useAlias: this.useSelectAlias }));
  }
  renderBcsSwitch() {
    if (this.showBusinessClassificationSelector && this.referenceType === index_esm_min.p.BusinessClass) {
      return this.renderBcs();
    }
    else {
      return this.renderAutocomplete();
    }
  }
  renderAutocomplete() {
    return (index.h("bp-sdk-autocomplete-naics-container", { answerId: this.answerId, choiceId: this.choiceId, choices: this.choices, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, required: this.isRequired, touched: this.touched }));
  }
  renderBcs() {
    return (index.h("bp-sdk-business-classification-selector-container", { answerId: this.answerId, choiceId: this.choiceId, choices: this.choices, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, required: this.isRequired, touched: this.touched }));
  }
  renderDialog() {
    return (index.h("bp-sdk-radio-dialog", { answeredBySource: this.answeredBySource, answerId: this.answerId, choiceId: this.choiceId, choices: this.choices, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, isRequired: this.isRequired, label: this.text, labelledBy: this.labelledBy, pristine: this.pristine, questionId: this.questionId, touched: this.touched }));
  }
  renderCheckbox() {
    return (index.h("bp-sdk-checkbox-input", { answeredBySource: this.answeredBySource, answerId: this.answerId, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.text, labelledBy: this.labelledBy, pristine: this.pristine, questionId: this.questionId, required: this.isRequired, touched: this.touched, value: !!this.value }));
  }
  renderRadio() {
    return (index.h("bp-sdk-radio-input", { answeredBySource: this.answeredBySource, answerId: this.answerId, choiceId: this.choiceId, choices: this.choices, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.text, labelledBy: this.labelledBy, pristine: this.pristine, questionId: this.questionId, required: this.isRequired, touched: this.touched }));
  }
  renderCoverageSelector() {
    return (index.h("bp-sdk-product-list-container", { answeredBySource: this.answeredBySource, answerId: this.answerId, choiceId: this.choiceId, choiceIds: this.choiceIds, choices: this.choices, code: this.code, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, isMultiple: this.isMultiple, isReadOnly: this.isReadOnly, label: this.placeholder, labelledBy: this.labelledBy, pristine: this.pristine, questionId: this.questionId, required: this.isRequired, touched: this.touched }));
  }
  renderQuestionPoolItemContainer() {
    return (index.h("bp-sdk-add-question-pool-item-container", { helpText: this.helpText, questionId: this.questionId, questionSetId: this.questionSetId, text: this.text }));
  }
  renderDeletePool() {
    return index.h("bp-sdk-delete-question-pool-item-container", { text: this.text, answerPoolId: this.answerPoolId });
  }
  renderVehicleAutocomplete() {
    return (index.h("bp-sdk-autocomplete-input", { allowFallthrough: this.referenceType != 'years', answeredBySource: this.answeredBySource, answerId: this.answerId, choiceId: this.choiceId, choices: this.choices, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, required: this.isRequired, showNoChoicesFallback: false, touched: this.touched }));
  }
};
BpSdkDynamicInput.style = bpSdkDynamicInputCss;

/**
 * A faster alternative to `Function#apply`, this function invokes `func`
 * with the `this` binding of `thisArg` and the arguments of `args`.
 *
 * @private
 * @param {Function} func The function to invoke.
 * @param {*} thisArg The `this` binding of `func`.
 * @param {Array} args The arguments to invoke `func` with.
 * @returns {*} Returns the result of `func`.
 */
function apply(func, thisArg, args) {
  switch (args.length) {
    case 0: return func.call(thisArg);
    case 1: return func.call(thisArg, args[0]);
    case 2: return func.call(thisArg, args[0], args[1]);
    case 3: return func.call(thisArg, args[0], args[1], args[2]);
  }
  return func.apply(thisArg, args);
}

var _apply = apply;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeMax = Math.max;

/**
 * A specialized version of `baseRest` which transforms the rest array.
 *
 * @private
 * @param {Function} func The function to apply a rest parameter to.
 * @param {number} [start=func.length-1] The start position of the rest parameter.
 * @param {Function} transform The rest array transform.
 * @returns {Function} Returns the new function.
 */
function overRest(func, start, transform) {
  start = nativeMax(start === undefined ? (func.length - 1) : start, 0);
  return function() {
    var args = arguments,
        index = -1,
        length = nativeMax(args.length - start, 0),
        array = Array(length);

    while (++index < length) {
      array[index] = args[start + index];
    }
    index = -1;
    var otherArgs = Array(start + 1);
    while (++index < start) {
      otherArgs[index] = args[index];
    }
    otherArgs[start] = transform(array);
    return _apply(func, this, otherArgs);
  };
}

var _overRest = overRest;

/**
 * Creates a function that returns `value`.
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Util
 * @param {*} value The value to return from the new function.
 * @returns {Function} Returns the new constant function.
 * @example
 *
 * var objects = _.times(2, _.constant({ 'a': 1 }));
 *
 * console.log(objects);
 * // => [{ 'a': 1 }, { 'a': 1 }]
 *
 * console.log(objects[0] === objects[1]);
 * // => true
 */
function constant(value) {
  return function() {
    return value;
  };
}

var constant_1 = constant;

var defineProperty = (function() {
  try {
    var func = isEqual._getNative(Object, 'defineProperty');
    func({}, '', {});
    return func;
  } catch (e) {}
}());

var _defineProperty = defineProperty;

/**
 * The base implementation of `setToString` without support for hot loop shorting.
 *
 * @private
 * @param {Function} func The function to modify.
 * @param {Function} string The `toString` result.
 * @returns {Function} Returns `func`.
 */
var baseSetToString = !_defineProperty ? identity_1 : function(func, string) {
  return _defineProperty(func, 'toString', {
    'configurable': true,
    'enumerable': false,
    'value': constant_1(string),
    'writable': true
  });
};

var _baseSetToString = baseSetToString;

/** Used to detect hot functions by number of calls within a span of milliseconds. */
var HOT_COUNT = 800,
    HOT_SPAN = 16;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeNow = Date.now;

/**
 * Creates a function that'll short out and invoke `identity` instead
 * of `func` when it's called `HOT_COUNT` or more times in `HOT_SPAN`
 * milliseconds.
 *
 * @private
 * @param {Function} func The function to restrict.
 * @returns {Function} Returns the new shortable function.
 */
function shortOut(func) {
  var count = 0,
      lastCalled = 0;

  return function() {
    var stamp = nativeNow(),
        remaining = HOT_SPAN - (stamp - lastCalled);

    lastCalled = stamp;
    if (remaining > 0) {
      if (++count >= HOT_COUNT) {
        return arguments[0];
      }
    } else {
      count = 0;
    }
    return func.apply(undefined, arguments);
  };
}

var _shortOut = shortOut;

/**
 * Sets the `toString` method of `func` to return `string`.
 *
 * @private
 * @param {Function} func The function to modify.
 * @param {Function} string The `toString` result.
 * @returns {Function} Returns `func`.
 */
var setToString = _shortOut(_baseSetToString);

var _setToString = setToString;

/**
 * The base implementation of `_.rest` which doesn't validate or coerce arguments.
 *
 * @private
 * @param {Function} func The function to apply a rest parameter to.
 * @param {number} [start=func.length-1] The start position of the rest parameter.
 * @returns {Function} Returns the new function.
 */
function baseRest(func, start) {
  return _setToString(_overRest(func, start, identity_1), func + '');
}

var _baseRest = baseRest;

/** Used as the size to enable large array optimizations. */
var LARGE_ARRAY_SIZE = 200;

/**
 * The base implementation of methods like `_.difference` without support
 * for excluding multiple arrays or iteratee shorthands.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {Array} values The values to exclude.
 * @param {Function} [iteratee] The iteratee invoked per element.
 * @param {Function} [comparator] The comparator invoked per element.
 * @returns {Array} Returns the new array of filtered values.
 */
function baseDifference(array, values, iteratee, comparator) {
  var index = -1,
      includes = _arrayIncludes,
      isCommon = true,
      length = array.length,
      result = [],
      valuesLength = values.length;

  if (!length) {
    return result;
  }
  if (iteratee) {
    values = _arrayMap(values, isEqual._baseUnary(iteratee));
  }
  if (comparator) {
    includes = _arrayIncludesWith;
    isCommon = false;
  }
  else if (values.length >= LARGE_ARRAY_SIZE) {
    includes = isEqual._cacheHas;
    isCommon = false;
    values = new isEqual._SetCache(values);
  }
  outer:
  while (++index < length) {
    var value = array[index],
        computed = iteratee == null ? value : iteratee(value);

    value = (comparator || value !== 0) ? value : 0;
    if (isCommon && computed === computed) {
      var valuesIndex = valuesLength;
      while (valuesIndex--) {
        if (values[valuesIndex] === computed) {
          continue outer;
        }
      }
      result.push(value);
    }
    else if (!includes(values, computed, comparator)) {
      result.push(value);
    }
  }
  return result;
}

var _baseDifference = baseDifference;

/** Built-in value references. */
var spreadableSymbol = isEqual._Symbol ? isEqual._Symbol.isConcatSpreadable : undefined;

/**
 * Checks if `value` is a flattenable `arguments` object or array.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is flattenable, else `false`.
 */
function isFlattenable(value) {
  return isEqual.isArray_1(value) || isEqual.isArguments_1(value) ||
    !!(spreadableSymbol && value && value[spreadableSymbol]);
}

var _isFlattenable = isFlattenable;

/**
 * The base implementation of `_.flatten` with support for restricting flattening.
 *
 * @private
 * @param {Array} array The array to flatten.
 * @param {number} depth The maximum recursion depth.
 * @param {boolean} [predicate=isFlattenable] The function invoked per iteration.
 * @param {boolean} [isStrict] Restrict to values that pass `predicate` checks.
 * @param {Array} [result=[]] The initial result value.
 * @returns {Array} Returns the new flattened array.
 */
function baseFlatten(array, depth, predicate, isStrict, result) {
  var index = -1,
      length = array.length;

  predicate || (predicate = _isFlattenable);
  result || (result = []);

  while (++index < length) {
    var value = array[index];
    if (depth > 0 && predicate(value)) {
      if (depth > 1) {
        // Recursively flatten arrays (susceptible to call stack limits).
        baseFlatten(value, depth - 1, predicate, isStrict, result);
      } else {
        isEqual._arrayPush(result, value);
      }
    } else if (!isStrict) {
      result[result.length] = value;
    }
  }
  return result;
}

var _baseFlatten = baseFlatten;

/**
 * The base implementation of methods like `_.xor`, without support for
 * iteratee shorthands, that accepts an array of arrays to inspect.
 *
 * @private
 * @param {Array} arrays The arrays to inspect.
 * @param {Function} [iteratee] The iteratee invoked per element.
 * @param {Function} [comparator] The comparator invoked per element.
 * @returns {Array} Returns the new array of values.
 */
function baseXor(arrays, iteratee, comparator) {
  var length = arrays.length;
  if (length < 2) {
    return length ? _baseUniq(arrays[0]) : [];
  }
  var index = -1,
      result = Array(length);

  while (++index < length) {
    var array = arrays[index],
        othIndex = -1;

    while (++othIndex < length) {
      if (othIndex != index) {
        result[index] = _baseDifference(result[index] || array, arrays[othIndex], iteratee, comparator);
      }
    }
  }
  return _baseUniq(_baseFlatten(result, 1), iteratee, comparator);
}

var _baseXor = baseXor;

/**
 * This method is like `_.isArrayLike` except that it also checks if `value`
 * is an object.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an array-like object,
 *  else `false`.
 * @example
 *
 * _.isArrayLikeObject([1, 2, 3]);
 * // => true
 *
 * _.isArrayLikeObject(document.body.children);
 * // => true
 *
 * _.isArrayLikeObject('abc');
 * // => false
 *
 * _.isArrayLikeObject(_.noop);
 * // => false
 */
function isArrayLikeObject(value) {
  return isEqual.isObjectLike_1(value) && isEqual.isArrayLike_1(value);
}

var isArrayLikeObject_1 = isArrayLikeObject;

/**
 * Gets the last element of `array`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Array
 * @param {Array} array The array to query.
 * @returns {*} Returns the last element of `array`.
 * @example
 *
 * _.last([1, 2, 3]);
 * // => 3
 */
function last(array) {
  var length = array == null ? 0 : array.length;
  return length ? array[length - 1] : undefined;
}

var last_1 = last;

/**
 * This method is like `_.xor` except that it accepts `comparator` which is
 * invoked to compare elements of `arrays`. The order of result values is
 * determined by the order they occur in the arrays. The comparator is invoked
 * with two arguments: (arrVal, othVal).
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Array
 * @param {...Array} [arrays] The arrays to inspect.
 * @param {Function} [comparator] The comparator invoked per element.
 * @returns {Array} Returns the new array of filtered values.
 * @example
 *
 * var objects = [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }];
 * var others = [{ 'x': 1, 'y': 1 }, { 'x': 1, 'y': 2 }];
 *
 * _.xorWith(objects, others, _.isEqual);
 * // => [{ 'x': 2, 'y': 1 }, { 'x': 1, 'y': 1 }]
 */
var xorWith = _baseRest(function(arrays) {
  var comparator = last_1(arrays);
  comparator = typeof comparator == 'function' ? comparator : undefined;
  return _baseXor(isEqual._arrayFilter(arrays, isArrayLikeObject_1), undefined, comparator);
});

var xorWith_1 = xorWith;

const bpSdkDynamicInputEventContainerCss = "";

const BpSdkDynamicInputEventContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.saveAnswer = index.createEvent(this, "saveAnswer", 7);
    this.removeActiveAnswer = index.createEvent(this, "removeActiveAnswer", 7);
    this.SAVE_ANSWER_DEBOUNCE_MS = 250;
    this.debouncedEmit = debounce.debounce_1(this.emitSaveAnswer, this.SAVE_ANSWER_DEBOUNCE_MS);
    this.onFocusIn = () => {
      var _a, _b, _c;
      if (this.inputComponentType === index_esm_min.t.DropDown && !((_b = (_a = this.answer) === null || _a === void 0 ? void 0 : _a.question) === null || _b === void 0 ? void 0 : _b.multiple)) {
        this.removeActiveAnswer.emit();
      }
      else {
        this.updateActiveAnswerId((_c = this.answer) === null || _c === void 0 ? void 0 : _c.id);
      }
    };
    this.onFocusOut = () => {
      this.touched = true;
      if (this.hasPendingUpdate) {
        this.emitSaveAnswer(this.lastAnswer);
      }
      this.determineErrors(this.errors, this.touched, this.pristine);
    };
    this.answer = undefined;
    this.shouldHideLabel = false;
    this.useSelectAlias = false;
    this.showBusinessClassificationSelector = false;
    this.errors = undefined;
    this.label = undefined;
    this.labelledBy = undefined;
    this.updateActiveAnswerId = undefined;
    this.updateErrors = undefined;
    this.referenceTypes = index_esm_min.se;
    this.fieldType = '';
    this.isCoverageType = true;
    this.labelId = 'a11y-';
    this.isLabelledField = false;
    this.inputComponentType = undefined;
    this._label = '';
    this.lastAnswer = undefined;
    this.touched = false;
    this.pristine = true;
    this.useExternal = false;
    this.isDropdown = true;
    this.isNumeric = false;
    this._errors = [];
    this.hasPendingUpdate = false;
  }
  resetState() {
    var _a;
    this.lastAnswer = undefined;
    this.touched = false;
    this.pristine = true;
    this.answerId = (_a = this.answer) === null || _a === void 0 ? void 0 : _a.id;
    this.debouncedEmit.cancel();
  }
  connectedCallback() {
    this.resetState();
  }
  onAnswerChange(answer) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    const code = (_b = (_a = answer === null || answer === void 0 ? void 0 : answer.question) === null || _a === void 0 ? void 0 : _a.code) !== null && _b !== void 0 ? _b : '';
    const id = (_c = answer === null || answer === void 0 ? void 0 : answer.id) !== null && _c !== void 0 ? _c : '';
    const fieldType = (_e = (_d = answer === null || answer === void 0 ? void 0 : answer.question) === null || _d === void 0 ? void 0 : _d.field_type) !== null && _e !== void 0 ? _e : '';
    const referenceType = (_g = (_f = answer === null || answer === void 0 ? void 0 : answer.question) === null || _f === void 0 ? void 0 : _f.reference_type) !== null && _g !== void 0 ? _g : '';
    this.fieldType = fieldType;
    this.isCoverageType = index_esm_min.se.includes(referenceType);
    this.labelId = `a11y-${code}-${id}`;
    this.isLabelledField = index_esm_min.ce.labelledFields.includes(fieldType) && !this.isCoverageType;
    this.inputComponentType = this.getComponentType(fieldType);
    this.isDropdown = index_esm_min.ce.dropdownFields.includes(this.inputComponentType);
    this.isNumeric = index_esm_min.ce.numberFields.includes(fieldType);
    this.updateLabel(answer === null || answer === void 0 ? void 0 : answer.question, this.label, this.shouldHideLabel);
    // Sometimes components are reused without being disconnected,
    // so we need to reset state if the answer id is different
    if (((_h = this.answer) === null || _h === void 0 ? void 0 : _h.id) !== this.answerId) {
      this.resetState();
    }
  }
  onHideLabelChange(shouldHideLabel) {
    var _a;
    this.updateLabel((_a = this.answer) === null || _a === void 0 ? void 0 : _a.question, this.label, shouldHideLabel);
  }
  onLabelChange(label) {
    var _a;
    this.updateLabel((_a = this.answer) === null || _a === void 0 ? void 0 : _a.question, label, this.shouldHideLabel);
  }
  updateLabel(question, label, shouldHideLabel) {
    var _a;
    if (!shouldHideLabel) {
      this._label = (_a = (label || (question === null || question === void 0 ? void 0 : question.text))) !== null && _a !== void 0 ? _a : '';
    }
    else {
      this._label = '';
    }
  }
  onErrorsChange(errors, oldErrors) {
    if (JSON.stringify(errors) !== JSON.stringify(oldErrors)) {
      this.determineErrors(errors, this.touched, this.pristine);
    }
  }
  onTouchedChange(touched, oldValue) {
    if (touched !== oldValue) {
      this.determineErrors(this.errors, touched, this.pristine);
    }
  }
  onPristineChange(pristine, oldValue) {
    if (pristine !== oldValue) {
      this.determineErrors(this.errors, this.touched, pristine);
    }
  }
  determineErrors(errors, touched, pristine) {
    this._errors = touched && !pristine ? errors : [];
  }
  updateErrorState(answer) {
    var _a;
    this.pristine = false;
    const errors = index_esm_min$1.dc(answer, index_esm_min$1.cc(answer));
    if (xorWith_1((_a = this.errors) !== null && _a !== void 0 ? _a : [], errors, isEqual.isEqual_1).length > 0) {
      this.updateErrors({ answer, errors });
    }
    this.errors = errors;
    this.determineErrors(this.errors, this.touched, this.pristine);
  }
  onMakeDirty() {
    this.touched = true;
    this.pristine = false;
  }
  makeDirty() {
    this.pristine = false;
  }
  onValueUpdate(event) {
    if (this.useExternal) {
      return;
    }
    const { detail } = event;
    if (index_esm_min$1.Fe(this.lastAnswer, detail)) {
      if (index_esm_min$1.$L(this.answer, detail)) {
        const answer = index_esm_min$1.bl(Object.assign({}, this.answer), detail);
        this.updateErrorState(answer);
        if (this.isDropdown) {
          this.removeActiveAnswer.emit();
        }
      }
      this.lastAnswer = detail;
      this.updateValue(detail);
    }
  }
  emitSaveAnswer(newValue) {
    if (this.hasPendingUpdate) {
      this.saveAnswer.emit({
        answer: Object.assign({}, this.answer),
        new_value: newValue,
      });
      this.hasPendingUpdate = false;
    }
  }
  unique(keys) {
    return Object.keys(keys
      .filter((key) => key != null)
      .reduce((acc, key) => (Object.assign(Object.assign({}, acc), { [key]: key })), {}));
  }
  cleanValue(value) {
    if (value == null) {
      return value;
    }
    else if (typeof value !== 'string' && Array.isArray(value)) {
      return this.unique(value);
    }
    else if (value &&
      (this.fieldType === index_esm_min.t.SocialSecurityNumber || this.fieldType === index_esm_min.t.FederalEmployeeIdentification)) {
      // NOTE: This is a very targeted fix for a bug with FEIN / SSN where the asterisk characters were getting stripped on
      // question set reload.
      // This regex will basically remove all characters that are not one of the following:
      //   a number (\d)
      //   a . character
      //   a - character
      //   a * character
      //
      // If we remove the star characters, then since the backend sends sensitive fields with * characters, the fields
      // will not be "valid" and can cause the user to not be able to edit and save previous question sets without re-entering
      // FEIN / SSN data.
      return value.replace(/[^\d.\*-]/g, '');
    }
    else if (value && this.isNumeric) {
      return value.replace(/[^\d.-]/g, '');
    }
    else {
      return value;
    }
  }
  save(data) {
    this.hasPendingUpdate = true;
    this.debouncedEmit(data);
  }
  updateValue(data) {
    const sanitizedData = this.cleanValue(data);
    this.save(sanitizedData);
  }
  onUseExternalChange(useExternal) {
    if (!useExternal) {
      this.unloadFocusEvents();
    }
  }
  loadFocusEvents() {
    if (!this.useExternal) {
      this.el.addEventListener('focusin', this.onFocusIn);
      this.el.addEventListener('focusout', this.onFocusOut);
    }
  }
  unloadFocusEvents() {
    var _a, _b;
    (_a = this.el) === null || _a === void 0 ? void 0 : _a.removeEventListener('focusin', this.onFocusIn);
    (_b = this.el) === null || _b === void 0 ? void 0 : _b.removeEventListener('focusout', this.onFocusOut);
  }
  getComponentType(fieldType) {
    let componentType = fieldType;
    if (index_esm_min.ce.textFields.includes(fieldType)) {
      componentType = 'text';
    }
    else if (index_esm_min.ce.maskedFields.includes(fieldType)) {
      componentType = 'masked';
    }
    if (this.isCoverageType) {
      componentType = 'coverage_type';
    }
    return componentType;
  }
  componentWillLoad() {
    var _a;
    this.useExternal = !!customElements.get('bp-sdk-external-dynamic-input-event-container');
    customElements.whenDefined('bp-sdk-external-dynamic-input-event-container').then(() => {
      this.useExternal = true;
      this.unloadFocusEvents();
    });
    this.onAnswerChange(this.answer);
    this.updateLabel((_a = this.answer) === null || _a === void 0 ? void 0 : _a.question, this.label, this.shouldHideLabel);
  }
  componentDidLoad() {
    this.loadFocusEvents();
  }
  disconnectedCallback() {
    this.unloadFocusEvents();
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-dynamic-input-event-container", { answer: this.answer, useSelectAlias: this.useSelectAlias, showBusinessClassificationSelector: this.showBusinessClassificationSelector, errors: this.errors, shouldHideLabel: this.shouldHideLabel, labelId: this.labelId, label: this.label, labelledBy: this.labelledBy, referenceTypes: this.referenceTypes, updateActiveAnswerId: this.updateActiveAnswerId, updateErrors: this.updateErrors }));
  }
  renderInternal() {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _22, _23, _24, _25, _26, _27, _28, _29, _30, _31, _32, _33;
    return (index.h("bp-sdk-dynamic-input", { answerId: (_a = this.answer) === null || _a === void 0 ? void 0 : _a.id, answerPoolId: (_b = this.answer) === null || _b === void 0 ? void 0 : _b.answer_pool_id, applicationFormId: (_c = this.answer) === null || _c === void 0 ? void 0 : _c.application_form_id, choiceId: (_d = this.answer) === null || _d === void 0 ? void 0 : _d.choice_id, choiceIds: (_e = this.answer) === null || _e === void 0 ? void 0 : _e.choice_ids, choices: (_g = (_f = this.answer) === null || _f === void 0 ? void 0 : _f.question) === null || _g === void 0 ? void 0 : _g.choices, code: (_j = (_h = this.answer) === null || _h === void 0 ? void 0 : _h.question) === null || _j === void 0 ? void 0 : _j.code, displayType: (_k = this.answer) === null || _k === void 0 ? void 0 : _k.display_type, errors: this.errors, errorText: (_m = (_l = this.answer) === null || _l === void 0 ? void 0 : _l.question) === null || _m === void 0 ? void 0 : _m.error_text, fieldType: (_p = (_o = this.answer) === null || _o === void 0 ? void 0 : _o.question) === null || _p === void 0 ? void 0 : _p.field_type, helpText: (_r = (_q = this.answer) === null || _q === void 0 ? void 0 : _q.question) === null || _r === void 0 ? void 0 : _r.help_text, answeredBySource: this.answeredBySource(), inputComponentType: this.inputComponentType, isAutocomplete: !!((_t = (_s = this.answer) === null || _s === void 0 ? void 0 : _s.question) === null || _t === void 0 ? void 0 : _t.autocomplete), isCompleted: !!((_u = this.answer) === null || _u === void 0 ? void 0 : _u.is_completed), isCoverageType: this.isCoverageType, isHidden: !!((_w = (_v = this.answer) === null || _v === void 0 ? void 0 : _v.question) === null || _w === void 0 ? void 0 : _w.is_hidden), isLabelledField: !!this.isLabelledField, isMultiple: !!((_y = (_x = this.answer) === null || _x === void 0 ? void 0 : _x.question) === null || _y === void 0 ? void 0 : _y.multiple), isReadOnly: !!((_z = this.answer) === null || _z === void 0 ? void 0 : _z.is_readonly) || !!((_1 = (_0 = this.answer) === null || _0 === void 0 ? void 0 : _0.question) === null || _1 === void 0 ? void 0 : _1.is_readonly), isRequired: !!(((_2 = this.answer) === null || _2 === void 0 ? void 0 : _2.required) || ((_4 = (_3 = this.answer) === null || _3 === void 0 ? void 0 : _3.question) === null || _4 === void 0 ? void 0 : _4.required)), isSensitive: !!((_6 = (_5 = this.answer) === null || _5 === void 0 ? void 0 : _5.question) === null || _6 === void 0 ? void 0 : _6.is_sensitive), isTrackable: !!((_8 = (_7 = this.answer) === null || _7 === void 0 ? void 0 : _7.question) === null || _8 === void 0 ? void 0 : _8.trackable), label: this._label, labelId: this.labelId, labelledBy: this.labelledBy, maxDate: (_10 = (_9 = this.answer) === null || _9 === void 0 ? void 0 : _9.question) === null || _10 === void 0 ? void 0 : _10.max_date, maxValue: (_12 = (_11 = this.answer) === null || _11 === void 0 ? void 0 : _11.question) === null || _12 === void 0 ? void 0 : _12.max_value, minDate: (_14 = (_13 = this.answer) === null || _13 === void 0 ? void 0 : _13.question) === null || _14 === void 0 ? void 0 : _14.min_date, minValue: (_16 = (_15 = this.answer) === null || _15 === void 0 ? void 0 : _15.question) === null || _16 === void 0 ? void 0 : _16.min_value, order: (_18 = (_17 = this.answer) === null || _17 === void 0 ? void 0 : _17.question) === null || _18 === void 0 ? void 0 : _18.order, pattern: (_20 = (_19 = this.answer) === null || _19 === void 0 ? void 0 : _19.question) === null || _20 === void 0 ? void 0 : _20.pattern, placeholder: (_22 = (_21 = this.answer) === null || _21 === void 0 ? void 0 : _21.question) === null || _22 === void 0 ? void 0 : _22.placeholder, pristine: this.pristine, questionId: (_24 = (_23 = this.answer) === null || _23 === void 0 ? void 0 : _23.question) === null || _24 === void 0 ? void 0 : _24.id, questionGroupId: (_26 = (_25 = this.answer) === null || _25 === void 0 ? void 0 : _25.question) === null || _26 === void 0 ? void 0 : _26.question_group_id, questionSetId: (_28 = (_27 = this.answer) === null || _27 === void 0 ? void 0 : _27.question) === null || _28 === void 0 ? void 0 : _28.question_set_id, referenceType: (_30 = (_29 = this.answer) === null || _29 === void 0 ? void 0 : _29.question) === null || _30 === void 0 ? void 0 : _30.reference_type, showBusinessClassificationSelector: this.showBusinessClassificationSelector, shouldShowInput: !!(this.answer && this.answer.active && this.answer.display_type === 'public' && this.answer.question), text: (_32 = (_31 = this.answer) === null || _31 === void 0 ? void 0 : _31.question) === null || _32 === void 0 ? void 0 : _32.text, touched: this.touched, useSelectAlias: this.useSelectAlias, value: (_33 = this.answer) === null || _33 === void 0 ? void 0 : _33.value }));
  }
  answeredBySource() {
    var _a, _b;
    if ((_a = this.answer) === null || _a === void 0 ? void 0 : _a.answered_by_consumer) {
      return 'Consumer';
    }
    return (_b = this.answer) === null || _b === void 0 ? void 0 : _b.answered_by_source;
  }
  get el() { return index.getElement(this); }
  static get watchers() { return {
    "answer": ["onAnswerChange"],
    "shouldHideLabel": ["onHideLabelChange"],
    "label": ["onLabelChange"],
    "errors": ["onErrorsChange"],
    "touched": ["onTouchedChange"],
    "pristine": ["onPristineChange"],
    "useExternal": ["onUseExternalChange"]
  }; }
};
BpSdkDynamicInputEventContainer.style = bpSdkDynamicInputEventContainerCss;

const bpSdkDynamicInputReduxContainerCss = "";

const BpSdkDynamicInputReduxContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.errorsUpdate = index.createEvent(this, "errorsUpdate", 7);
    this.handleUpdateActiveAnswerId = (answerId) => {
      this.updateActiveAnswerId(answerId);
    };
    this.handleSubscriptions = () => {
      if (store.canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        store.store.mapDispatchToProps(this, {
          updateActiveAnswerId: sdkRedux.updateActiveAnswerId,
          updateErrors: sdkRedux.updateErrors,
        });
        this.storeUnsubscribe = store.store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        errorState: state.application.errors,
        activeId: state.application.questionSets.activeAnswerId,
        showBusinessClassificationSelector: sdkRedux.isFeatureEnabled(state, 'bcs'),
      };
    };
    this.answer = undefined;
    this.label = undefined;
    this.labelledBy = undefined;
    this.useSelectAlias = false;
    this.showBusinessClassificationSelector = false;
    this.shouldHideLabel = false;
    this.errorState = {};
    this.activeId = '';
    this.isAccumulatorAnswer = false;
    this.updateAccumulatorErrors = undefined;
    this.code = undefined;
    this.errors = [];
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-dynamic-input-redux-container');
    customElements.whenDefined('bp-sdk-external-dynamic-input-redux-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
    this.onErrorsStateChange(this.errorState);
    this.onAnswerChange(this.answer);
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  onErrorsStateChange(errorState) {
    this.getErrors(this.answer, errorState);
    this.errorsUpdate.emit(this.errors);
  }
  onAnswerChange(answer) {
    this.getErrors(answer, this.errorState);
  }
  getErrors(answer, errorsState) {
    var _a;
    this.errors = (_a = errorsState[answer === null || answer === void 0 ? void 0 : answer.id]) !== null && _a !== void 0 ? _a : [];
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-dynamic-input-redux-container", { activeId: this.activeId, answer: this.answer, errors: this.errors, errorState: this.errorState, isAccumulatorAnswer: this.isAccumulatorAnswer, label: this.label, labelledBy: this.labelledBy, shouldHideLabel: this.shouldHideLabel, showBusinessClassificationSelector: this.showBusinessClassificationSelector, updateActiveAnswerId: this.handleUpdateActiveAnswerId, updateAccumulatorErrors: this.updateAccumulatorErrors, updateErrors: this.updateErrors, useSelectAlias: this.useSelectAlias, code: this.code }));
  }
  renderInternal() {
    return (index.h("bp-sdk-dynamic-input-event-container", { answer: this.answer, errors: this.errors, label: this.label, labelledBy: this.labelledBy, shouldHideLabel: this.shouldHideLabel, showBusinessClassificationSelector: this.showBusinessClassificationSelector, updateActiveAnswerId: this.updateActiveAnswerId, updateErrors: this.updateErrors, useSelectAlias: this.useSelectAlias }));
  }
  get el() { return index.getElement(this); }
  static get watchers() { return {
    "errorState": ["onErrorsStateChange"],
    "answer": ["onAnswerChange"]
  }; }
};
BpSdkDynamicInputReduxContainer.style = bpSdkDynamicInputReduxContainerCss;

const bpSdkGooglePlacesAutocompleteContainerCss = "";

const BpSdkGooglePlacesAutocompleteContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.handleSubscriptions = () => {
      if (store.canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        store.store.mapDispatchToProps(this, { removeActiveAnswerId: sdkRedux.removeActiveAnswerId });
        this.storeUnsubscribe = store.store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        googleApiToken: state.config.googleApiToken,
        isAutocompleteEnabled: sdkRedux.isAutocompleteEnabled(state),
      };
    };
    this.answerId = undefined;
    this.code = undefined;
    this.labelId = undefined;
    this.placeholder = '';
    this.filter = undefined;
    this.label = undefined;
    this.labelledBy = undefined;
    this.required = undefined;
    this.errors = [];
    this.errorText = undefined;
    this.touched = false;
    this.pristine = true;
    this.isCompleted = false;
    this.isReadOnly = false;
    this.questionId = undefined;
    this.fieldType = undefined;
    this.min = -1;
    this.max = -1;
    this.referenceType = undefined;
    this.helpText = undefined;
    this.googleApiToken = undefined;
    this.isAutocompleteEnabled = undefined;
    this.answeredBySource = undefined;
    this.autoComplete = undefined;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-google-places-autocomplete-container');
    customElements.whenDefined('bp-sdk-external-google-places-autocomplete-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code: this.code,
      fieldType: this.fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
  }
  onPlacesUpdate() {
    if (!this.useExternal) {
      this.removeActiveAnswerId();
    }
  }
  onReferenceTypeChange(referenceType) {
    this.updateAutocomplete({
      referenceType,
      code: this.code,
      fieldType: this.fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
  }
  onCodeChange(code) {
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code,
      fieldType: this.fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
  }
  onFieldTypeChange(fieldType) {
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code: this.code,
      fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
  }
  onIsAutocompleteEnabledChange(isAutocompleteEnabled) {
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code: this.code,
      fieldType: this.fieldType,
      isAutocompleteEnabled,
    });
  }
  updateAutocomplete({ code, fieldType, referenceType, isAutocompleteEnabled, }) {
    this.autoComplete = isAutocompleteEnabled ? index_esm_min$1.f4({ referenceType, code, fieldType }) : undefined;
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-google-places-autocomplete-container", { answeredBySource: this.answeredBySource, answerId: this.answerId, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, filter: this.filter, googleApiToken: this.googleApiToken, labelId: this.labelId, label: this.label, labelledBy: this.labelledBy, max: this.max, min: this.min, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, referenceType: this.referenceType, required: this.required, touched: this.touched }));
  }
  renderInternal() {
    return (index.h("bp-sdk-google-places-autocomplete", { answeredBySource: this.answeredBySource, answerId: this.answerId, autoComplete: this.autoComplete, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, filter: this.filter, googleApiKey: this.googleApiToken, helpText: this.helpText, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, max: this.max, min: this.min, placeholder: this.placeholder, questionId: this.questionId, required: this.required, pristine: this.pristine, touched: this.touched }));
  }
  get el() { return index.getElement(this); }
  static get watchers() { return {
    "referenceType": ["onReferenceTypeChange"],
    "code": ["onCodeChange"],
    "fieldType": ["onFieldTypeChange"],
    "isAutocompleteEnabled": ["onIsAutocompleteEnabledChange"]
  }; }
};
BpSdkGooglePlacesAutocompleteContainer.style = bpSdkGooglePlacesAutocompleteContainerCss;

const bpSdkIncrementInputCss = "";

const BpSdkIncrementInput = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.answerId = undefined;
    this.questionId = undefined;
    this.text = undefined;
    this.labelId = undefined;
    this.fieldType = 'text';
    this.placeholder = '';
    this.pattern = undefined;
    this.code = undefined;
    this.required = false;
    this.min = -1;
    this.max = -1;
    this.errors = [];
    this.errorText = undefined;
    this.touched = false;
    this.pristine = true;
    this.isCompleted = false;
    this.isReadOnly = false;
    this.label = undefined;
    this.labelledBy = undefined;
    this.isEnabled = true;
    this.referenceType = undefined;
    this.helpText = undefined;
    this.answeredBySource = undefined;
    this.useExternal = false;
  }
  resetState() { }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-increment-input');
    customElements.whenDefined('bp-sdk-external-increment-input').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-increment-input", { answerId: this.answerId, code: this.code, errorText: this.errorText, errors: this.errors, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isEnabled: this.isEnabled, isReadOnly: this.isReadOnly, labelId: this.labelId, label: this.label, labelledBy: this.labelledBy, max: this.max, min: this.min, pattern: this.pattern, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, referenceType: this.referenceType, required: this.required, text: this.text, touched: this.touched }));
  }
  renderInternal() {
    return (index.h("bp-sdk-text-input-container", { answerId: this.answerId, code: this.code, errorText: this.errorText, errors: this.errors, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isEnabled: this.isEnabled, isReadOnly: this.isReadOnly, labelId: this.labelId, label: this.label, labelledBy: this.labelledBy, max: this.max, min: this.min, pattern: this.pattern, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, referenceType: this.referenceType, required: this.required, text: this.text, touched: this.touched }));
  }
};
BpSdkIncrementInput.style = bpSdkIncrementInputCss;

const bpSdkLabelCss = "";

const BpSdkLabel = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.label = undefined;
    this.helpText = undefined;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-label');
    customElements.whenDefined('bp-sdk-external-label').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return index.h("bp-sdk-external-label", { label: this.label, helpText: this.helpText });
  }
  renderInternal() {
    return [
      index.h("bp-sdk-label-before", { label: this.label, helpText: this.helpText }),
      index.h("div", { class: "bp-sdk-label__container" }, index.h("div", { class: "bp-sdk-label__content", innerHTML: this.label })),
      index.h("bp-sdk-label-after", { label: this.label, helpText: this.helpText }),
    ];
  }
};
BpSdkLabel.style = bpSdkLabelCss;

const bpSdkMaskedInputContainerCss = "";

const BpSdkMaskedInputContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.handleSubscriptions = () => {
      if (store.canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        this.storeUnsubscribe = store.store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        isAutocompleteEnabled: sdkRedux.isAutocompleteEnabled(state),
      };
    };
    this.answerId = undefined;
    this.labelId = undefined;
    this.errors = [];
    this.code = undefined;
    this.errorText = undefined;
    this.isCompleted = undefined;
    this.isReadOnly = false;
    this.min = undefined;
    this.minDate = undefined;
    this.max = undefined;
    this.maxDate = undefined;
    this.fieldType = undefined;
    this.labelledBy = undefined;
    this.pattern = undefined;
    this.required = false;
    this.referenceType = undefined;
    this.value = undefined;
    this.placeholder = '';
    this.touched = false;
    this.pristine = true;
    this.questionId = undefined;
    this.label = undefined;
    this.isAutocompleteEnabled = undefined;
    this.helpText = undefined;
    this.answeredBySource = undefined;
    this.canHide = false;
    this.useComplexMaskLogic = false;
    this.mask = undefined;
    this.options = undefined;
    this.autoComplete = undefined;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-masked-input-container');
    customElements.whenDefined('bp-sdk-external-masked-input-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
    this.onFieldTypeChange(this.fieldType);
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code: this.code,
      fieldType: this.fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
  }
  onReferenceTypeChange(referenceType) {
    this.updateAutocomplete({
      referenceType,
      code: this.code,
      fieldType: this.fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
  }
  onCodeChange(code) {
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code,
      fieldType: this.fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
  }
  onIsAutocompleteEnabledChange(isAutocompleteEnabled) {
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code: this.code,
      fieldType: this.fieldType,
      isAutocompleteEnabled,
    });
  }
  onFieldTypeChange(fieldType) {
    let mask;
    let useComplexMaskLogic = false;
    let canHide = false;
    let options;
    switch (fieldType) {
      case index_esm_min.t.Phone:
        mask = '(999) 999-9999';
        options = {
          placeholder: '#',
        };
        break;
      case index_esm_min.t.Percentage:
        mask = '999%';
        options = {
          placeholder: ' ',
        };
        break;
      case index_esm_min.t.Currency:
        mask = 'integer';
        options = {
          // unlike percentage, currency placeholder must be empty
          // otherwise, inputmask will show "$integer" for placeholder
          placeholder: '',
          prefix: '$',
        };
        break;
      case index_esm_min.t.Date:
        mask = 'datetime';
        options = {
          placeholder: '#',
          inputFormat: 'mm/dd/yyyy',
        };
        useComplexMaskLogic = true;
        canHide = true;
        break;
      case index_esm_min.t.SocialSecurityNumber:
        mask = '999-99-9999';
        options = {
          placeholder: '#',
        };
        useComplexMaskLogic = true;
        canHide = true;
        break;
      case index_esm_min.t.FederalEmployeeIdentification:
        mask = '99-9999999';
        options = {
          placeholder: '#',
        };
        useComplexMaskLogic = true;
        canHide = true;
        break;
    }
    this.mask = mask;
    this.options = options;
    this.canHide = canHide;
    this.useComplexMaskLogic = useComplexMaskLogic;
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code: this.code,
      fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
  }
  updateAutocomplete({ code, fieldType, referenceType, isAutocompleteEnabled, }) {
    this.autoComplete = isAutocompleteEnabled ? index_esm_min$1.f4({ referenceType, code, fieldType }) : undefined;
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-masked-input-container", { answerId: this.answerId, labelId: this.labelId, code: this.code, errorText: this.errorText, errors: this.errors, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelledBy: this.labelledBy, mask: this.mask, maxDate: this.maxDate, max: this.max, minDate: this.minDate, min: this.min, options: this.options, pattern: this.pattern, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, referenceType: this.referenceType, required: this.required, shouldHideOnBlur: this.canHide, touched: this.touched, useComplexMaskLogic: this.useComplexMaskLogic, value: this.value }));
  }
  renderInternal() {
    return (index.h("bp-sdk-masked-input", { answerId: this.answerId, autoComplete: this.autoComplete, canHide: this.canHide, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, mask: this.mask, max: this.max, maxDate: this.maxDate, min: this.min, minDate: this.minDate, options: this.options, pattern: this.pattern, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, required: this.required, touched: this.touched, useComplexMaskLogic: this.useComplexMaskLogic, value: this.value }));
  }
  get el() { return index.getElement(this); }
  static get watchers() { return {
    "referenceType": ["onReferenceTypeChange"],
    "code": ["onCodeChange"],
    "isAutocompleteEnabled": ["onIsAutocompleteEnabledChange"],
    "fieldType": ["onFieldTypeChange"]
  }; }
};
BpSdkMaskedInputContainer.style = bpSdkMaskedInputContainerCss;

const bpSdkProductListContainerCss = "";

const BpSdkProductListContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.answerId = undefined;
    this.questionId = undefined;
    this.touched = false;
    this.pristine = true;
    this.fieldType = undefined;
    this.label = 'What kind of coverage are you looking for?';
    this.labelledBy = undefined;
    this.choices = [];
    this.choiceId = undefined;
    this.choiceIds = [];
    this.code = undefined;
    this.errorText = undefined;
    this.isMultiple = true;
    this.isReadOnly = false;
    this.helpText = undefined;
    this.answeredBySource = undefined;
    this.required = undefined;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-product-list-container');
    customElements.whenDefined('bp-sdk-external-product-list-container').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-product-list-container", { answeredBySource: this.answeredBySource, answerId: this.answerId, choiceId: this.choiceId, choiceIds: this.choiceIds, choices: this.choices, code: this.code, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, isMultiple: this.isMultiple, isReadOnly: this.isReadOnly, label: this.label, labelledBy: this.labelledBy, pristine: this.pristine, questionId: this.questionId, touched: this.touched, required: this.required }));
  }
  renderInternal() {
    return (index.h("bp-sdk-product-list", { answeredBySource: this.answeredBySource, answerId: this.answerId, choiceId: this.choiceId, choiceIds: this.choiceIds, choices: this.choices, code: this.code, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, isMultiple: this.isMultiple, isReadOnly: this.isReadOnly, label: this.label, labelledBy: this.labelledBy, pristine: this.pristine, questionId: this.questionId, touched: this.touched, required: this.required }));
  }
};
BpSdkProductListContainer.style = bpSdkProductListContainerCss;

const bpSdkRadioDialogCss = "";

const BpSdkRadioDialog = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.answerId = undefined;
    this.questionId = undefined;
    this.fieldType = undefined;
    this.code = undefined;
    this.label = undefined;
    this.labelledBy = undefined;
    this.choices = [];
    this.choiceId = undefined;
    this.errors = undefined;
    this.errorText = undefined;
    this.touched = false;
    this.pristine = true;
    this.isRequired = undefined;
    this.isReadOnly = false;
    this.isCompleted = false;
    this.helpText = undefined;
    this.answeredBySource = undefined;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-radio-dialog');
    customElements.whenDefined('bp-sdk-external-radio-dialog').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-radio-dialog", { answeredBySource: this.answeredBySource, answerId: this.answerId, choiceId: this.choiceId, choices: this.choices, code: this.code, errorText: this.errorText, errors: this.errors, fieldType: this.fieldType, helpText: this.helpText, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, isRequired: this.isRequired, label: this.label, labelledBy: this.labelledBy, pristine: this.pristine, questionId: this.questionId, touched: this.touched }));
  }
  renderInternal() {
    return (index.h("bp-sdk-dialog", { class: "bp-sdk-radio-dialog__container", code: this.code, isRequired: this.isRequired, questionId: this.questionId }, index.h("div", { class: "bp-sdk-radio-dialog__radio" }, index.h("bp-sdk-radio-input", { answeredBySource: this.answeredBySource, answerId: this.answerId, choiceId: this.choiceId, choices: this.choices, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelledBy: this.labelledBy, pristine: this.pristine, questionId: this.questionId, required: this.isRequired, touched: this.touched }))));
  }
};
BpSdkRadioDialog.style = bpSdkRadioDialogCss;

const bpSdkSelectInputContainerCss = "";

const BpSdkSelectInputContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.handleSubscriptions = () => {
      if (store.canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        this.storeUnsubscribe = store.store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        isAutocompleteEnabled: sdkRedux.isAutocompleteEnabled(state),
      };
    };
    this.answerId = undefined;
    this.placeholder = '';
    this.useAlias = false;
    this.code = undefined;
    this.choiceId = undefined;
    this.choiceIds = [];
    this.multiple = false;
    this.choices = [];
    this.value = undefined;
    this.labelId = undefined;
    this.errors = undefined;
    this.errorText = undefined;
    this.touched = false;
    this.pristine = true;
    this.isCompleted = false;
    this.isReadOnly = false;
    this.questionId = undefined;
    this.fieldType = undefined;
    this.required = undefined;
    this.label = undefined;
    this.labelledBy = undefined;
    this.referenceType = undefined;
    this.isAutocompleteEnabled = undefined;
    this.helpText = undefined;
    this.answeredBySource = undefined;
    this.autoComplete = undefined;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-select-input-container');
    customElements.whenDefined('bp-sdk-external-select-input-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code: this.code,
      fieldType: this.fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
  }
  onReferenceTypeChange(referenceType) {
    this.updateAutocomplete({
      referenceType,
      code: this.code,
      fieldType: this.fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
  }
  onCodeChange(code) {
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code,
      fieldType: this.fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
  }
  onFieldTypeChange(fieldType) {
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code: this.code,
      fieldType,
      isAutocompleteEnabled: this.isAutocompleteEnabled,
    });
  }
  onIsAutocompleteEnabledChange(isAutocompleteEnabled) {
    this.updateAutocomplete({
      referenceType: this.referenceType,
      code: this.code,
      fieldType: this.fieldType,
      isAutocompleteEnabled,
    });
  }
  updateAutocomplete({ code, fieldType, referenceType, isAutocompleteEnabled, }) {
    this.autoComplete = isAutocompleteEnabled ? index_esm_min$1.f4({ referenceType, code, fieldType }) : undefined;
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-select-input-container", { answerId: this.answerId, choiceId: this.choiceId, choiceIds: this.choiceIds, choices: this.choices, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: this.fieldType, helpText: this.helpText, answeredBySource: this.answeredBySource, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, multiple: this.multiple, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, referenceType: this.referenceType, required: this.required, touched: this.touched, useAlias: this.useAlias, value: this.value }));
  }
  renderInternal() {
    return (index.h("bp-sdk-select-input", { answerId: this.answerId, autoComplete: this.autoComplete, choiceId: this.choiceId, choiceIds: this.choiceIds, choices: this.choices, code: this.code, errors: this.errors, errorText: this.errorText, helpText: this.helpText, answeredBySource: this.answeredBySource, fieldType: this.fieldType, isCompleted: this.isCompleted, isReadOnly: this.isReadOnly, label: this.label, labelId: this.labelId, labelledBy: this.labelledBy, multiple: this.multiple, placeholder: this.placeholder, pristine: this.pristine, questionId: this.questionId, required: this.required, touched: this.touched, useAlias: this.useAlias }));
  }
  get el() { return index.getElement(this); }
  static get watchers() { return {
    "referenceType": ["onReferenceTypeChange"],
    "code": ["onCodeChange"],
    "fieldType": ["onFieldTypeChange"],
    "isAutocompleteEnabled": ["onIsAutocompleteEnabledChange"]
  }; }
};
BpSdkSelectInputContainer.style = bpSdkSelectInputContainerCss;

exports.bp_sdk_add_question_pool_item_container = BpSdkAddQuestionPoolItemContainer;
exports.bp_sdk_autocomplete_naics_container = BpSdkAutocompleteNaicsContainer;
exports.bp_sdk_business_classification_selector_container = BpSdkBusinessClassificationSelectorContainer;
exports.bp_sdk_checkbox_input = BpSdkCheckboxInput;
exports.bp_sdk_date_input_container = BpSdkDateInputContainer;
exports.bp_sdk_delete_question_pool_item_container = BpSdkDeleteQuestionPoolItemContainer;
exports.bp_sdk_driver_input_container = BpSdkDriverInputContainer;
exports.bp_sdk_dynamic_input = BpSdkDynamicInput;
exports.bp_sdk_dynamic_input_event_container = BpSdkDynamicInputEventContainer;
exports.bp_sdk_dynamic_input_redux_container = BpSdkDynamicInputReduxContainer;
exports.bp_sdk_google_places_autocomplete_container = BpSdkGooglePlacesAutocompleteContainer;
exports.bp_sdk_increment_input = BpSdkIncrementInput;
exports.bp_sdk_label = BpSdkLabel;
exports.bp_sdk_masked_input_container = BpSdkMaskedInputContainer;
exports.bp_sdk_product_list_container = BpSdkProductListContainer;
exports.bp_sdk_radio_dialog = BpSdkRadioDialog;
exports.bp_sdk_select_input_container = BpSdkSelectInputContainer;
