'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-64113c20.js');
const store = require('./store-fe3d3434.js');
const sdkRedux = require('@boldpenguin/sdk-redux');

const bpSdkFilterApplicationFormStateContainerCss = "";

const BpSdkFilterApplicationFormStateContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.handleSubscriptions = () => {
      if (store.canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        this.storeUnsubscribe = store.store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        state: sdkRedux.getApplicationState(state),
      };
    };
    this.targetState = undefined;
    this.state = undefined;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-filter-application-form-state-container');
    customElements.whenDefined('bp-sdk-external-filter-application-form-state-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return index.h("bp-sdk-external-filter-application-form-state-container", { targetState: this.targetState, state: this.state });
  }
  renderInternal() {
    return (this.state === this.targetState && (index.h("div", { class: "bp-sdk-filter-application-form-state-container__container" }, index.h("host", null))));
  }
};
BpSdkFilterApplicationFormStateContainer.style = bpSdkFilterApplicationFormStateContainerCss;

exports.bp_sdk_filter_application_form_state_container = BpSdkFilterApplicationFormStateContainer;
