'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-64113c20.js');
const store = require('./store-fe3d3434.js');
const sdkRedux = require('@boldpenguin/sdk-redux');

const BpSdkMessageContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.handleSubscriptions = () => {
      if (store.canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        this.storeUnsubscribe = store.store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        messages: sdkRedux.getMessages(state),
      };
    };
    this.messages = undefined;
    this.useExternal = false;
    this.lastMessage = undefined;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-message-container');
    customElements.whenDefined('bp-sdk-external-message-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
  }
  handleMessagesUpdate(messages) {
    this.lastMessage = messages[this.messages.length - 1];
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  componentWillUpdate() {
    this.handleSubscriptions();
  }
  render() {
    if (!store.canGetStore()) {
      return null;
    }
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return index.h("bp-sdk-external-message-container", { messages: this.messages });
  }
  renderInternal() {
    return this.lastMessage && index.h("bp-sdk-message", { message: this.lastMessage });
  }
  get el() { return index.getElement(this); }
  static get watchers() { return {
    "messages": ["handleMessagesUpdate"]
  }; }
};

exports.bp_sdk_message_container = BpSdkMessageContainer;
