'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-64113c20.js');
const store = require('./store-fe3d3434.js');
const sdkRedux = require('@boldpenguin/sdk-redux');

const BpSdkRoot = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.completedAt = undefined;
    this.disableWebSocket = false;
    this.enableLifecycleEvents = false;
    this.disableToolbar = false;
    this.storeLoaded = false;
  }
  onDisabledWebSocket(disableWebSocket) {
    sdkRedux.store.dispatch(sdkRedux.setWebSocketConfig({ enableWebsocket: !disableWebSocket }));
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    store.store.setStore(sdkRedux.store);
    this.storeLoaded = true;
    this.onDisabledWebSocket(this.disableWebSocket);
  }
  render() {
    if (!store.canGetStore()) {
      return null;
    }
    return (this.storeLoaded && (index.h("bp-sdk-setup-container", null, [!!this.enableLifecycleEvents && index.h("bp-sdk-custom-event-container", null), !this.disableToolbar && index.h("bp-sdk-interview-toolbar", null)], index.h("slot", null))));
  }
  static get watchers() { return {
    "disableWebSocket": ["onDisabledWebSocket"]
  }; }
};

exports.bp_sdk_root = BpSdkRoot;
