'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-64113c20.js');
const store = require('./store-fe3d3434.js');
const index_esm_min = require('./index.esm.min-d6127cb6.js');
const sdkRedux = require('@boldpenguin/sdk-redux');

const bpSdkTakeOverCss = "";

const BpSdkTakeOver = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.isLocked = undefined;
    this.isCloned = undefined;
    this.canTakeOver = undefined;
    this.isOwner = undefined;
    this.isFormLoaded = undefined;
    this.takeOverHandler = undefined;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-take-over');
    customElements.whenDefined('bp-sdk-external-take-over').then(() => {
      this.useExternal = true;
    });
  }
  shouldRender() {
    return this.isFormLoaded && this.canTakeOver && !this.isOwner && !this.isCloned && !this.isLocked;
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-take-over", { canTakeOver: this.canTakeOver, isCloned: this.isCloned, isLocked: this.isLocked, isOwner: this.isOwner, isFormLoaded: this.isFormLoaded, shouldRender: this.shouldRender(), takeOverHandler: this.takeOverHandler }));
  }
  renderInternal() {
    return (this.shouldRender() && (index.h("div", { class: "bp-sdk-take-over__container" }, index.h("bp-sdk-take-over-button", { onClick: this.takeOverHandler }))));
  }
};
BpSdkTakeOver.style = bpSdkTakeOverCss;

const bpSdkTakeOverContainerCss = "";

const BpSdkTakeOverContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.handleSubscriptions = () => {
      if (store.canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        store.store.mapDispatchToProps(this, {
          cloneApplicationForm: sdkRedux.cloneApplicationForm,
        });
        this.storeUnsubscribe = store.store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        appFormId: sdkRedux.getFormId(state),
        isLocked: sdkRedux.isFormLocked(state),
        isCloned: sdkRedux.isFormCloned(state),
        canTakeOver: sdkRedux.userHasPermission(state, { permission: index_esm_min.S.TakeOver }),
        isOwner: sdkRedux.doesUserOwnApplicationForm(state),
        isFormLoaded: sdkRedux.isFormLoaded(state),
        config: sdkRedux.getPartnerEngineConfig(state),
      };
    };
    this.takeOverHandler = () => {
      this.cloneApplicationForm({
        appFormId: this.appFormId,
        config: this.config,
      });
    };
    this.isLocked = undefined;
    this.isCloned = undefined;
    this.canTakeOver = undefined;
    this.isOwner = undefined;
    this.isFormLoaded = undefined;
    this.appFormId = undefined;
    this.config = undefined;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-take-over-container');
    customElements.whenDefined('bp-sdk-external-take-over-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-take-over-container", { appFormId: this.appFormId, canTakeOver: this.canTakeOver, config: this.config, isCloned: this.isCloned, isLocked: this.isLocked, isOwner: this.isOwner, isFormLoaded: this.isFormLoaded, takeOverHandler: this.takeOverHandler }));
  }
  renderInternal() {
    return (index.h("bp-sdk-take-over", { canTakeOver: this.canTakeOver, isCloned: this.isCloned, isLocked: this.isLocked, isOwner: this.isOwner, isFormLoaded: this.isFormLoaded, takeOverHandler: this.takeOverHandler }));
  }
  get el() { return index.getElement(this); }
};
BpSdkTakeOverContainer.style = bpSdkTakeOverContainerCss;

exports.bp_sdk_take_over = BpSdkTakeOver;
exports.bp_sdk_take_over_container = BpSdkTakeOverContainer;
