import { r as registerInstance, h } from './index-8f8983b3.js';
import { f as fx } from './index.esm.min-7be3b852.js';

const bpSdkButtonCss = ".bp-sdk-button{--bp-sdk-button-color:var(--theme-color);color:var(--bp-sdk-button-color)}.bp-sdk-button__text{pointer-events:none}";

const BpSdkButton = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.text = undefined;
    this.buttonId = fx(8);
    this.buttonDisabled = false;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-button');
    customElements.whenDefined('bp-sdk-external-button').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (h("bp-sdk-external-button", { buttonId: this.buttonId, text: this.text, buttonDisabled: this.buttonDisabled }, h("slot", null)));
  }
  renderInternal() {
    return (h("button", { type: "button", class: "bp-sdk-button", id: this.buttonId, disabled: this.buttonDisabled }, h("slot", null), h("span", { class: "bp-sdk-button__text" }, this.text)));
  }
};
BpSdkButton.style = bpSdkButtonCss;

export { BpSdkButton as bp_sdk_button };
