import { r as registerInstance, h } from './index-8f8983b3.js';
import { c as canGetStore, s as store } from './store-6dda1ad2.js';

const bpSdkFilterContainerCss = "";

const BpSdkFilterContainer = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.handleSubscriptions = () => {
      if (canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        this.storeUnsubscribe = store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        isHidden: !!(this.filter && this.filter(state)),
      };
    };
    this.filter = undefined;
    this.isHidden = false;
    this.useExternal = false;
  }
  resetState() { }
  onFilterChange() {
    this.handleSubscriptions();
  }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-filter-container');
    customElements.whenDefined('bp-sdk-external-filter-container').then(() => {
      this.useExternal = true;
    });
    this.onFilterChange();
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return h("bp-sdk-external-filter-container", { filter: this.filter, isHidden: this.isHidden });
  }
  renderInternal() {
    return (!this.isHidden && (h("div", { class: "bp-sdk-filter-container__container" }, h("host", null))));
  }
  static get watchers() { return {
    "filter": ["onFilterChange"]
  }; }
};
BpSdkFilterContainer.style = bpSdkFilterContainerCss;

export { BpSdkFilterContainer as bp_sdk_filter_container };
