import { r as registerInstance, h } from './index-8f8983b3.js';
import { c as canGetStore, s as store } from './store-6dda1ad2.js';
import { getApplicationFormState } from '@boldpenguin/sdk-redux';

const bpSdkFilterRemoteApplicationFormStateContainerCss = "";

const BpSdkFilterRemoteApplicationFormStateContainer = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.handleSubscriptions = () => {
      if (canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        this.storeUnsubscribe = store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        state: getApplicationFormState(state),
      };
    };
    this.targetState = undefined;
    this.state = undefined;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-filter-remote-application-form-state-container');
    customElements.whenDefined('bp-sdk-external-filter-remote-application-form-state-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return h("bp-sdk-external-filter-remote-application-form-state-container", { state: this.state, targetState: this.targetState });
  }
  renderInternal() {
    return (this.targetState === this.state && (h("div", { class: "bp-sdk-filter-remote-application-form-state-container__container" }, h("host", null))));
  }
};
BpSdkFilterRemoteApplicationFormStateContainer.style = bpSdkFilterRemoteApplicationFormStateContainerCss;

export { BpSdkFilterRemoteApplicationFormStateContainer as bp_sdk_filter_remote_application_form_state_container };
