import { r as registerInstance, c as createEvent, h } from './index-8f8983b3.js';

const bpSdkNextButtonCss = "";

const BpSdkNextButton = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.navigateNext = createEvent(this, "navigateNext", 7);
    this.text = '';
    this.icon = 'chevron-right';
    this.buttonDisabled = false;
    this.cssClasses = undefined;
    this.useExternal = false;
  }
  resetState() { }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-next-button');
    customElements.whenDefined('bp-sdk-external-next-button').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (h("bp-sdk-external-next-button", { buttonDisabled: this.buttonDisabled, cssClasses: this.cssClasses, icon: this.icon, text: this.text }));
  }
  renderInternal() {
    return (h("div", { class: "bp-sdk-next-button__container" }, h("bp-sdk-button", { onClick: () => this.navigateNext.emit(), text: this.text, buttonDisabled: this.buttonDisabled, class: this.cssClasses }, h("bp-sdk-icon-container", { name: this.icon }))));
  }
};
BpSdkNextButton.style = bpSdkNextButtonCss;

export { BpSdkNextButton as bp_sdk_next_button };
