import { r as registerInstance, h, c as createEvent, g as getElement } from './index-8f8983b3.js';
import { P, R, T, p, s, C as Ce } from './index.esm.min-531f07d6.js';
import { q as ec, s as c9, F as Fe, l as l4, f as fx, i as ix, a as vx } from './index.esm.min-7be3b852.js';
import { getVehicleOptionsMakes, getVehicleOptionsSelection, getVehicleOptionsModels, loadYears, loadMakes, loadModels, loadConfigurations, loadSingleQuestionSet, loadSingleApplicationForm, selectVehicle, resetSelectedVehicle, loadFullVehicleOptions, setVehicleSelection, getPartnerEngineConfig, getVehicleOptionsYears, getVehicleSelectionState, getDisplayFriendlyVehicleOptionsSelection, loadVin, getVehicleOptionsConfigurations, getVehicleOptionsVin, getVinSelectionState } from '@boldpenguin/sdk-redux';
import { c as canGetStore, s as store } from './store-6dda1ad2.js';
import { d as debounce_1 } from './debounce-fb08fcae.js';
import { i as isEqual_1 } from './isEqual-080a9417.js';
import { V as VehicleVinService } from './vehicle-vin.service-b6ae53c6.js';
import './_commonjsHelpers-5e4b1d1a.js';

const bpSdkVehicleDeleteButtonCss = ".bp-sdk-vehicle-delete-button{appearance:none;font-weight:bold;cursor:pointer;height:100%;width:3rem}";

const BpSdkVehicleDeleteButton = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-vehicle-delete-button');
    customElements.whenDefined('bp-sdk-external-vehicle-delete-button').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return h("bp-sdk-external-vehicle-delete-button", null);
  }
  renderInternal() {
    return (h("button", { type: "button", class: "bp-sdk-vehicle-delete-button" }, h("bp-sdk-model-container", { name: "trashcan" }, "Delete")));
  }
};
BpSdkVehicleDeleteButton.style = bpSdkVehicleDeleteButtonCss;

const bpSdkVehicleEditButtonCss = ".bp-sdk-vehicle-edit-button{appearance:none;font-weight:bold;cursor:pointer;height:100%;width:3rem}";

const BpSdkVehicleEditButton = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-vehicle-edit-button');
    customElements.whenDefined('bp-sdk-external-vehicle-edit-button').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return h("bp-sdk-external-vehicle-edit-button", null);
  }
  renderInternal() {
    return (h("button", { type: "button", class: "bp-sdk-vehicle-edit-button" }, "Edit"));
  }
};
BpSdkVehicleEditButton.style = bpSdkVehicleEditButtonCss;

const bpSdkVehicleGroupCss = "";

const BpSdkVehicleGroup = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.saveVehicle = createEvent(this, "saveVehicle", 7);
    this.saveButtonClick = () => {
      switch (this.selectedCAFlow) {
        case P.ymm:
          this.saveVehicle.emit(P.ymm);
          break;
        case P.vin:
          this.saveVehicle.emit(P.vin);
          break;
        case 'trailer':
          this.saveVehicle.emit(P.trailers);
          break;
      }
    };
    this.canSave = true;
    this.questionGroup = undefined;
    this.isVehicleTrailer = false;
    this.shouldShowTrailers = true;
    this.handleDelete = undefined;
    this.useExternal = false;
    this.flowAnswer = undefined;
    this.selectedCAFlow = 'none';
  }
  onQuestionSetChange(questionGroup) {
    this.flowAnswer = ec(questionGroup);
    this.selectedCAFlow = this.getSelectedVehicleInput();
  }
  resetState() {
    this.flowAnswer = ec(this.questionGroup);
  }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-vehicle-group');
    customElements.whenDefined('bp-sdk-external-vehicle-group').then(() => {
      this.useExternal = true;
    });
    this.onQuestionSetChange(this.questionGroup);
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderVehicleQuestions() {
    switch (this.selectedCAFlow) {
      case 'ymm':
        return h("bp-sdk-vehicle-interface", { questionGroup: this.questionGroup, canSave: this.canSave });
      case 'vin':
        return h("bp-sdk-vehicle-vin-container", { questionGroupId: c9(this.questionGroup) });
      case 'trailer':
        return this.shouldShowTrailers ? (h("bp-sdk-vehicle-interface", { questionGroup: this.questionGroup, isVehicleTrailer: true, canSave: this.canSave })) : ('');
      default:
        return '';
    }
  }
  renderExternal() {
    return (h("bp-sdk-external-vehicle-group", { canSave: this.canSave, isVehicleTrailer: this.isVehicleTrailer, questionGroup: this.questionGroup, shouldShowTrailers: this.shouldShowTrailers, handleDelete: this.handleDelete }));
  }
  renderInternal() {
    return (h("div", { class: "bp-sdk-vehicle-group__container" }, h("h2", null, "Vehicle Information"), h("bp-sdk-dynamic-input-redux-container", { answer: this.flowAnswer, label: "Choose how to add your vehicle" }), this.renderVehicleQuestions(), h("div", { class: "bp-sdk-row" }, h("bp-sdk-vehicle-delete-button", { onClick: this.handleDelete }), h("bp-sdk-vehicle-save-button", { buttonDisabled: !this.canSave, onClick: this.saveButtonClick, text: "Save Vehicle" }))));
  }
  getSelectedVehicleInput() {
    var _a;
    if (!this.flowAnswer) {
      return 'none';
    }
    const selectedCAFlow = this.flowAnswer.choice_id;
    const aliasOfSelectedChoice = (_a = this.flowAnswer.question.choices.find((choice) => choice.id === selectedCAFlow)) === null || _a === void 0 ? void 0 : _a.value;
    switch (aliasOfSelectedChoice) {
      case 'Year / Make / Model':
        return 'ymm';
      case 'VIN':
        return 'vin';
      case 'Trailer':
        return 'trailer';
      default:
        return 'none';
    }
  }
  static get watchers() { return {
    "questionGroup": ["onQuestionSetChange"]
  }; }
};
BpSdkVehicleGroup.style = bpSdkVehicleGroupCss;

const bpSdkVehicleInterfaceCss = "";

const vehicleQuestionCodes = {
  year: 'mqs_vehicle_year',
  make: 'mqs_vehicle_make',
  model: 'mqs_vehicle_model',
  configuration: 'mqs_vehicle_submodel',
};
const BpSdkVehicleInterface = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.saveVehicle = createEvent(this, "saveVehicle", 7);
    this.questionGroup = undefined;
    this.canSave = true;
    this.isVehicleTrailer = false;
    this.useExternal = false;
    this.answerIdMap = {
      year: '',
      make: '',
      model: '',
      configuration: '',
    };
  }
  onQuestionGroupChange() {
    this.answerIdMap = this.buildAnswerIdMap();
  }
  resetState() {
    this.answerIdMap = {
      year: '',
      make: '',
      model: '',
      configuration: '',
    };
  }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-vehicle-interface');
    customElements.whenDefined('bp-sdk-external-vehicle-interface').then(() => {
      this.useExternal = true;
    });
    this.answerIdMap = this.buildAnswerIdMap();
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return h("bp-sdk-external-vehicle-interface", { isVehicleTrailer: this.isVehicleTrailer, questionGroup: this.questionGroup });
  }
  renderInternal() {
    return (h("div", { class: "bp-sdk-vehicle-interface__container" }, h("bp-sdk-vehicle-years-container", { isVehicleTrailer: this.isVehicleTrailer, questionGroupId: c9(this.questionGroup), code: vehicleQuestionCodes.year, answerId: this.answerIdMap.year }), h("bp-sdk-vehicle-makes-container", { isVehicleTrailer: this.isVehicleTrailer, questionGroupId: c9(this.questionGroup), code: vehicleQuestionCodes.make, answerId: this.answerIdMap.make }), h("bp-sdk-vehicle-models-container", { isVehicleTrailer: this.isVehicleTrailer, questionGroupId: c9(this.questionGroup), code: vehicleQuestionCodes.model, answerId: this.answerIdMap.model }), h("bp-sdk-vehicle-configurations-container", { questionGroupId: c9(this.questionGroup), code: vehicleQuestionCodes.configuration, answerId: this.answerIdMap.configuration })));
  }
  buildAnswerIdMap() {
    var _a, _b, _c, _d, _e, _f;
    const answers = (_b = (_a = this.questionGroup) === null || _a === void 0 ? void 0 : _a.answers) !== null && _b !== void 0 ? _b : [];
    const yearAnswer = answers.find((answer) => answer.question.code === vehicleQuestionCodes.year);
    const makeAnswer = answers.find((answer) => answer.question.code === vehicleQuestionCodes.make);
    const modelAnswer = answers.find((answer) => answer.question.code === vehicleQuestionCodes.model);
    const configurationAnswer = answers.find((answer) => answer.question.code === vehicleQuestionCodes.configuration);
    return {
      year: (_c = yearAnswer === null || yearAnswer === void 0 ? void 0 : yearAnswer.id) !== null && _c !== void 0 ? _c : '',
      make: (_d = makeAnswer === null || makeAnswer === void 0 ? void 0 : makeAnswer.id) !== null && _d !== void 0 ? _d : '',
      model: (_e = modelAnswer === null || modelAnswer === void 0 ? void 0 : modelAnswer.id) !== null && _e !== void 0 ? _e : '',
      configuration: (_f = configurationAnswer === null || configurationAnswer === void 0 ? void 0 : configurationAnswer.id) !== null && _f !== void 0 ? _f : '',
    };
  }
  static get watchers() { return {
    "questionGroup": ["onQuestionGroupChange"]
  }; }
};
BpSdkVehicleInterface.style = bpSdkVehicleInterfaceCss;

const bpSdkVehicleMakesContainerCss = "";

const BpSdkVehicleMakesContainer = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.ymmcUpdate = createEvent(this, "ymmcUpdate", 7);
    this.handleSubscriptions = () => {
      if (canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        this.storeUnsubscribe = store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        makeOptions: getVehicleOptionsMakes(state, this.questionGroupId),
        selectedVehicle: getVehicleOptionsSelection(state, this.questionGroupId),
      };
    };
    this.onFocusOut = () => {
      this.touched = true;
      this.updateErrors(this.pristine, true, this.value);
    };
    this.answerId = undefined;
    this.code = undefined;
    this.makeOptions = {};
    this.selectedVehicle = {};
    this.questionGroupId = undefined;
    this.isVehicleTrailer = false;
    this.choices = [];
    this.filter = undefined;
    this.filteredChoices = [];
    this.useExternal = false;
    this.touched = false;
    this.pristine = true;
    this.value = undefined;
    this.errors = [];
  }
  resetState() {
    this.touched = false;
    this.pristine = true;
    this.value = undefined;
    this.errors = [];
  }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-vehicle-makes-container');
    customElements.whenDefined('bp-sdk-external-vehicle-makes-container').then(() => {
      this.useExternal = true;
    });
    this.onQuestionGroupIdChange();
  }
  onQuestionGroupIdChange() {
    this.handleSubscriptions();
  }
  onMakesChange(makes) {
    if (makes) {
      this.choices = this.convertMakesToChoices(makes);
      this.updateValue(makes, this.selectedVehicle);
    }
    else {
      this.updateValue(undefined, undefined);
    }
  }
  onVehicleSelectionChange(selection) {
    if (!(selection === null || selection === void 0 ? void 0 : selection.makeId)) {
      this.touched = false;
      this.pristine = true;
    }
    this.updateValue(this.makeOptions, selection);
  }
  updateValue(makes, selection) {
    this.value = !!(makes && (selection === null || selection === void 0 ? void 0 : selection.makeId)) ? makes[selection.makeId] : undefined;
  }
  onUseExternalChange(useExternal) {
    if (!useExternal) {
      this.unloadFocusEvents();
    }
  }
  loadFocusEvents() {
    if (!this.useExternal) {
      this.el.addEventListener('focusout', this.onFocusOut);
    }
  }
  unloadFocusEvents() {
    this.el.removeEventListener('focusout', this.onFocusOut);
  }
  componentDidLoad() {
    this.loadFocusEvents();
  }
  disconnectedCallback() {
    this.unloadFocusEvents();
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  onFilterUpdate({ detail }) {
    var _a;
    this.filter = (_a = detail === null || detail === void 0 ? void 0 : detail.value) !== null && _a !== void 0 ? _a : '';
  }
  onFilterChange(filter) {
    this.updateChoices(this.choices, filter);
  }
  onChoicesChange(choices) {
    this.updateChoices(choices, this.filter);
  }
  updateChoices(choices, filter = '') {
    const regex = new RegExp(`.*${filter}.*`, 'gi');
    this.filteredChoices = choices.filter((choice) => !!choice.value.match(regex));
  }
  onValueUpdate(evt) {
    var _a, _b;
    if (this.useExternal) {
      return;
    }
    this.pristine = false;
    const value = ((_a = evt.detail) !== null && _a !== void 0 ? _a : [])[0];
    if (Fe(value, this.value) && (this.errors.length === 0 || !!value)) {
      this.value = value;
      const displayValue = (_b = this.makeOptions[value]) !== null && _b !== void 0 ? _b : value;
      this.ymmcUpdate.emit({ type: R.Make, value, displayValue });
    }
  }
  onValueChange(value) {
    this.updateErrors(false, this.touched, value);
  }
  updateErrors(pristine, touched, value) {
    this.errors = l4(pristine, touched, value) ? ['required'] : [];
  }
  onMakeDirty() {
    this.touched = true;
    this.pristine = false;
    this.updateErrors(false, this.touched, this.value);
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (h("bp-sdk-external-vehicle-makes-container", { answerId: this.answerId, code: this.code, isVehicleTrailer: this.isVehicleTrailer, makeOptions: this.makeOptions, questionGroupId: this.questionGroupId, selectedVehicle: this.selectedVehicle }));
  }
  convertMakesToChoices(makes) {
    const choices = [];
    for (const makeId of Object.keys(makes)) {
      choices.push({ id: makeId, value: makes[makeId] });
    }
    choices.sort((a, b) => a.value.localeCompare(b.value));
    return choices;
  }
  renderInternal() {
    var _a;
    return (this.choices.length > 0 && (h("bp-sdk-vehicle-makes", { answerId: this.answerId, code: this.code, errors: this.errors, isVehicleTrailer: this.isVehicleTrailer, label: "Enter vehicle make", makes: this.filteredChoices, pristine: this.pristine, selectedMakeId: (_a = this.selectedVehicle) === null || _a === void 0 ? void 0 : _a.makeId, touched: this.touched })));
  }
  get el() { return getElement(this); }
  static get watchers() { return {
    "questionGroupId": ["onQuestionGroupIdChange"],
    "makeOptions": ["onMakesChange"],
    "selectedVehicle": ["onVehicleSelectionChange"],
    "useExternal": ["onUseExternalChange"],
    "filter": ["onFilterChange"],
    "choices": ["onChoicesChange"],
    "value": ["onValueChange"]
  }; }
};
BpSdkVehicleMakesContainer.style = bpSdkVehicleMakesContainerCss;

const bpSdkVehicleModelsContainerCss = "";

const BpSdkVehicleModelsContainer = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.ymmcUpdate = createEvent(this, "ymmcUpdate", 7);
    this.handleSubscriptions = () => {
      if (canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        this.storeUnsubscribe = store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        modelOptions: getVehicleOptionsModels(state, this.questionGroupId),
        selectedVehicle: getVehicleOptionsSelection(state, this.questionGroupId),
      };
    };
    this.onFocusOut = () => {
      this.touched = true;
      this.updateErrors(this.pristine, true, this.value);
    };
    this.answerId = undefined;
    this.code = undefined;
    this.modelOptions = {};
    this.selectedVehicle = {};
    this.questionGroupId = undefined;
    this.isVehicleTrailer = false;
    this.choices = [];
    this.useExternal = false;
    this.filter = undefined;
    this.filteredChoices = [];
    this.touched = false;
    this.pristine = true;
    this.value = undefined;
    this.errors = [];
  }
  resetState() {
    this.touched = false;
    this.pristine = true;
    this.value = undefined;
    this.errors = [];
  }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-vehicle-models-container');
    customElements.whenDefined('bp-sdk-external-vehicle-models-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
    this.onQuestionGroupIdChange();
  }
  onQuestionGroupIdChange() {
    this.handleSubscriptions();
  }
  onModelsChange(models) {
    this.choices = this.convertModelsToChoices(models);
    this.updateValue(models, this.selectedVehicle);
  }
  onSelectionChange(selection) {
    if (!(selection === null || selection === void 0 ? void 0 : selection.modelId)) {
      this.touched = false;
      this.pristine = true;
    }
    this.updateValue(this.modelOptions, selection);
  }
  onFilterUpdate({ detail }) {
    var _a;
    this.filter = (_a = detail === null || detail === void 0 ? void 0 : detail.value) !== null && _a !== void 0 ? _a : '';
  }
  onFilterChange(filter) {
    this.updateChoices(this.choices, filter);
  }
  onChoicesChange(choices) {
    this.updateChoices(choices, this.filter);
  }
  updateChoices(choices, filter = '') {
    const regex = new RegExp(`.*${filter}.*`, 'gi');
    this.filteredChoices = choices.filter((choice) => !!choice.value.match(regex));
  }
  updateValue(models, selection) {
    const newValue = !!(models && (selection === null || selection === void 0 ? void 0 : selection.modelId)) ? models[selection.modelId] : undefined;
    this.value = newValue;
  }
  componentDidLoad() {
    this.loadFocusEvents();
  }
  disconnectedCallback() {
    this.unloadFocusEvents();
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  onUseExternalChange(useExternal) {
    if (!useExternal) {
      this.unloadFocusEvents();
    }
  }
  loadFocusEvents() {
    if (!this.useExternal) {
      this.el.addEventListener('focusout', this.onFocusOut);
    }
  }
  unloadFocusEvents() {
    this.el.removeEventListener('focusout', this.onFocusOut);
  }
  onValueUpdate(evt) {
    var _a;
    if (this.useExternal) {
      return;
    }
    this.pristine = false;
    const value = ((_a = evt.detail) !== null && _a !== void 0 ? _a : [])[0];
    if (Fe(value, this.value) && (this.errors.length === 0 || !!value)) {
      this.value = value;
      this.ymmcUpdate.emit({ type: R.Model, value });
    }
  }
  onValueChange(value) {
    this.updateErrors(false, this.touched, value);
  }
  updateErrors(pristine, touched, value) {
    this.errors = l4(pristine, touched, value) ? ['required'] : [];
  }
  onMakeDirty() {
    this.touched = true;
    this.pristine = false;
    this.updateErrors(false, this.touched, this.value);
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (h("bp-sdk-external-vehicle-models-container", { answerId: this.answerId, code: this.code, isVehicleTrailer: this.isVehicleTrailer, modelOptions: this.modelOptions, questionGroupId: this.questionGroupId, selectedVehicle: this.selectedVehicle }));
  }
  convertModelsToChoices(models = {}) {
    const choices = [];
    for (const modelId of Object.keys(models)) {
      choices.push({ id: modelId, value: models[modelId] });
    }
    choices.sort((a, b) => a.value.localeCompare(b.value));
    return choices;
  }
  renderInternal() {
    var _a, _b;
    return ((((_a = this.selectedVehicle) === null || _a === void 0 ? void 0 : _a.makeId) || this.choices.length > 0) && (h("bp-sdk-vehicle-models", { answerId: this.answerId, code: this.code, errors: this.errors, isVehicleTrailer: this.isVehicleTrailer, label: "Enter vehicle model", models: this.filteredChoices, pristine: this.pristine, selectedModelId: (_b = this.selectedVehicle) === null || _b === void 0 ? void 0 : _b.modelId, touched: this.touched })));
  }
  get el() { return getElement(this); }
  static get watchers() { return {
    "questionGroupId": ["onQuestionGroupIdChange"],
    "modelOptions": ["onModelsChange"],
    "selectedVehicle": ["onSelectionChange"],
    "filter": ["onFilterChange"],
    "choices": ["onChoicesChange"],
    "useExternal": ["onUseExternalChange"],
    "value": ["onValueChange"]
  }; }
};
BpSdkVehicleModelsContainer.style = bpSdkVehicleModelsContainerCss;

const bpSdkVehiclePanelCss = "";

const BpSdkVehiclePanel = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.onClick = () => {
      if (this.isExpanded) {
        this.handleClose();
      }
      else {
        this.handleOpen();
      }
    };
    this.code = undefined;
    this.answers = [];
    this.questionGroup = undefined;
    this.canEdit = false;
    this.isEditing = false;
    this.isExpanded = true;
    this.canDelete = false;
    this.canSave = true;
    this.handleClose = undefined;
    this.handleOpen = undefined;
    this.handleDelete = undefined;
    this.handleEdit = undefined;
    this.isValid = true;
    this.vehicleInformation = { year: '', make: '', model: '', configuration: '' };
    this.vehicleLabel = 'Add new vehicle';
    this.shouldShowTrailers = false;
    this.isVehicleTrailer = false;
    this.useExternal = false;
    this.icon = '';
    this.labelledBy = undefined;
    this.ids = {
      year: fx(8),
      make: fx(8),
      model: fx(8),
      slot: fx(8),
    };
  }
  onIsValidChange(isValid) {
    this.icon = isValid ? 'check_circle' : 'error_outline';
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-vehicle-panel');
    customElements.whenDefined('bp-sdk-external-vehicle-panel').then(() => {
      this.useExternal = true;
    });
  }
  onVehicleInformationChange(vehicleInformation) {
    this.labelledBy = ix('', {
      [this.ids.year]: !!vehicleInformation.year,
      [this.ids.make]: !!vehicleInformation.make,
      [this.ids.model]: !!vehicleInformation.model,
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (h("bp-sdk-external-vehicle-panel", { answers: this.answers, canDelete: this.canDelete, canEdit: this.canEdit, canSave: this.canSave, code: this.code, handleClose: this.handleClose, handleDelete: this.handleDelete, handleEdit: this.handleEdit, handleOpen: this.handleOpen, isEditing: this.isEditing, isExpanded: this.isExpanded, isValid: this.isValid, isVehicleTrailer: this.isVehicleTrailer, questionGroup: this.questionGroup, shouldShowTrailers: this.shouldShowTrailers, vehicleInformation: this.vehicleInformation, vehicleLabel: this.vehicleLabel }));
  }
  renderContent() {
    return (h("div", { class: "bp-sdk-vehicle-panel__content", slot: `${this.ids.slot}-content` }, this.isValid && (h("bp-sdk-vehicle-panel-content", { additionalAnswers: this.answers, questionGroup: this.questionGroup, labelledBy: this.labelledBy }))));
  }
  renderInternal() {
    return (h("div", { class: "bp-sdk-vehicle-panel__container" }, this.isEditing && [
      h("bp-sdk-vehicle-group", { canSave: this.canSave, questionGroup: this.questionGroup, shouldShowTrailers: this.shouldShowTrailers, isVehicleTrailer: this.isVehicleTrailer, handleDelete: this.handleDelete }),
      this.renderContent(),
    ], !this.isEditing && [
      h("bp-sdk-icon-container", { name: this.icon }),
      h("bp-sdk-vehicle-panel-label", { class: "bp-sdk-vehicle-panel__label", vehicleLabel: this.vehicleLabel, onClick: this.onClick }),
      h("bp-sdk-vehicle-panel-buttons", { class: "bp-sdk-vehicle-panel__buttons", canDelete: this.canDelete, canEdit: this.canEdit, handleDelete: this.handleDelete, handleEdit: this.handleEdit }),
      this.renderContent(),
    ]));
  }
  static get watchers() { return {
    "isValid": ["onIsValidChange"],
    "vehicleInformation": ["onVehicleInformationChange"]
  }; }
};
BpSdkVehiclePanel.style = bpSdkVehiclePanelCss;

const bpSdkVehiclePanelButtonsCss = "";

const BpSdkVehiclePanelButtons = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.canDelete = false;
    this.canEdit = false;
    this.handleDelete = undefined;
    this.handleEdit = undefined;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-vehicle-panel-buttons');
    customElements.whenDefined('bp-sdk-external-vehicle-panel-buttons').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (h("bp-sdk-external-vehicle-panel-buttons", { canDelete: this.canDelete, canEdit: this.canEdit, handleDelete: this.handleDelete, handleEdit: this.handleEdit }));
  }
  renderInternal() {
    return (h("div", { class: "bp-sdk-vehicle-panel-buttons__container" }, this.canEdit && [
      this.canDelete && h("bp-sdk-vehicle-delete-button", { onClick: this.handleDelete }),
      h("bp-sdk-vehicle-edit-button", { onClick: this.handleEdit }),
    ]));
  }
};
BpSdkVehiclePanelButtons.style = bpSdkVehiclePanelButtonsCss;

const bpSdkVehiclePanelContainerCss = "";

const BpSdkVehiclePanelContainer = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.deleteItem = createEvent(this, "deleteItem", 7);
    this.saveAnswer = createEvent(this, "saveAnswer", 7);
    this.makeDisplayValue = '';
    this.handleSubscriptions = () => {
      if (canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        store.mapDispatchToProps(this, {
          loadYears,
          loadMakes,
          loadModels,
          loadConfigurations,
          loadSingleQuestionSet,
          loadSingleApplicationForm,
          selectVehicle,
          resetSelectedVehicle,
          loadFullVehicleOptions,
          setVehicleSelection,
        });
        this.storeUnsubscribe = store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        config: getPartnerEngineConfig(state),
        appFormId: state.application.form.id,
        yearOptions: getVehicleOptionsYears(state, this.questionGroupId),
        selectionStatus: getVehicleSelectionState(state, this.questionGroupId),
        vehicleInformation: getDisplayFriendlyVehicleOptionsSelection(state, this.questionGroupId),
      };
    };
    this.loadOptions = debounce_1((selection) => {
      this.loadFullVehicleOptions({
        year: selection.yearId,
        makeId: selection.makeId,
        modelId: selection.modelId,
        config: this.config,
        questionGroupId: this.questionGroupId,
        type: this.type,
      });
      this.setVehicleSelection({
        questionGroupId: this.questionGroupId,
        selection,
      });
    }, 100);
    this.setOptions = debounce_1((selection) => {
      this.setVehicleSelection({
        questionGroupId: this.questionGroupId,
        selection: Object.assign({ configurationId: undefined, makeId: undefined, modelId: undefined, yearId: undefined }, selection),
      });
    }, 100);
    this.onVehicleSaveCallback = () => {
      this.isSaving = false;
      this.isEditing = false;
      this.onQuestionGroupChange(this.questionGroup);
    };
    this.editVehicle = (e) => {
      e.stopPropagation();
      this.onEdit();
    };
    this.deleteVehicle = () => {
      this.deleteItem.emit(this.code);
    };
    this.onOpen = () => {
      this.canEdit = true;
      this.isEditing = false;
      this.isExpanded = true;
    };
    this.onClose = () => {
      this.canEdit = false;
      this.isEditing = false;
      this.isExpanded = false;
    };
    this.code = undefined;
    this.answers = [];
    this.questionGroup = undefined;
    this.canDelete = false;
    this.appFormId = undefined;
    this.config = undefined;
    this.yearOptions = {};
    this.selectionStatus = undefined;
    this.shouldShowTrailers = false;
    this.isVehicleTrailer = false;
    this.vehicleInformation = {
      year: '',
      make: '',
      model: '',
      configuration: '',
    };
    this.canEdit = true;
    this.canSave = false;
    this.isEditing = false;
    this.isExpanded = true;
    this.isSaving = false;
    this.isValid = true;
    this.useExternal = false;
    this._currentYear = undefined;
    this._currentMakeId = undefined;
    this._currentModelId = undefined;
    this._currentConfigId = undefined;
    this.questionGroupId = undefined;
    this.type = undefined;
    this.tabIndex = 0;
    this.vehicleLabel = '';
  }
  resetState() {
    this.canEdit = true;
    this.canSave = false;
    this.isEditing = false;
    this.isExpanded = true;
    this.isValid = true;
    this.type = undefined;
    this.vehicleLabel = '';
    this.makeDisplayValue = '';
  }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-vehicle-panel-container');
    customElements.whenDefined('bp-sdk-external-vehicle-panel-container').then(() => {
      this.useExternal = true;
    });
    this.onIsVehicleTrailerChanged(this.isVehicleTrailer);
    this.onTabChanged(this.tabIndex);
    this.onQuestionGroupChange(this.questionGroup);
  }
  handleTabChanged({ detail }) {
    if (this.useExternal) {
      return;
    }
    this.tabIndex = detail;
  }
  onTabChanged(tab) {
    this.updateType(tab, this.isVehicleTrailer);
  }
  onIsVehicleTrailerChanged(isVehicleTrailer) {
    this.updateType(this.tabIndex, isVehicleTrailer);
  }
  updateType(tab, isVehicleTrailer) {
    if (this.useExternal) {
      return;
    }
    const type = isVehicleTrailer || this.isTrailerTab(tab) ? T.trailers : undefined;
    if (type !== this.type) {
      this.setVehicleSelection({
        questionGroupId: this.questionGroupId,
        selection: { yearId: undefined, modelId: undefined, makeId: undefined, configurationId: undefined },
      });
      this.populateVehicleOptions(this.questionGroup);
      this.type = type;
      this.fetchYears();
    }
  }
  isTrailerTab(tab) {
    var _a;
    const flow = ec(this.questionGroup);
    const trailerTab = flow === null || flow === void 0 ? void 0 : flow.question.choices.find((choice) => !!choice.value.match(/trailer/gi));
    const order = (_a = trailerTab === null || trailerTab === void 0 ? void 0 : trailerTab.order) !== null && _a !== void 0 ? _a : 2; // we know what order should be
    return tab === order;
  }
  populateVehicleOptions(questionGroup) {
    var _a, _b, _c, _d;
    const existingVehicleAnswer = (_a = questionGroup === null || questionGroup === void 0 ? void 0 : questionGroup.answers) === null || _a === void 0 ? void 0 : _a.find((ans) => ans.question.reference_type === p.CommercialAutoJson);
    if (!(existingVehicleAnswer === null || existingVehicleAnswer === void 0 ? void 0 : existingVehicleAnswer.value)) {
      return;
    }
    const vehicleJson = JSON.parse(existingVehicleAnswer.value);
    let year = Number(vehicleJson.year);
    let makeId = (_b = vehicleJson.make_id) === null || _b === void 0 ? void 0 : _b.toString();
    let modelId = (_c = vehicleJson.model_id) === null || _c === void 0 ? void 0 : _c.toString();
    let configurationId = (_d = vehicleJson.configuration_id) === null || _d === void 0 ? void 0 : _d.toString();
    //account for fallthrough free-text values for trailers
    if (vehicleJson.category === 'Trailers') {
      if (!makeId)
        makeId = vehicleJson.make;
      if (!modelId)
        modelId = vehicleJson.model;
    }
    const isValidState = !Number.isNaN(year) && makeId && modelId && (configurationId || vehicleJson.category === 'Trailers');
    this._currentYear = year;
    this._currentMakeId = makeId;
    this._currentModelId = modelId;
    this._currentConfigId = configurationId;
    this.canSave = this.isVehicleInputComplete();
    if (isValidState) {
      this.loadOptions({
        yearId: year,
        makeId,
        modelId,
        configurationId,
      });
    }
  }
  onQuestionGroupChange(questionGroup, oldQuestionGroup) {
    if (this.isSaving || isEqual_1(questionGroup, oldQuestionGroup)) {
      return;
    }
    this.questionGroupId = c9(questionGroup);
    this.populateVehicleOptions(questionGroup);
    this.handleSubscriptions();
    this.vehicleLabel = this.getVehicleLabel();
    this.canSave = this.isVehicleInputComplete();
  }
  onVehicleInformationChange(vehicleInformation) {
    this.isValid = !!(vehicleInformation.make && vehicleInformation.model && vehicleInformation.year);
  }
  onOptionsUpdate(updateEvent) {
    var _a;
    const data = updateEvent.detail;
    if (!(data === null || data === void 0 ? void 0 : data.value)) {
      return;
    }
    switch (data.type) {
      case R.Year:
        const currentYear = Number(data.value);
        if (!Number.isNaN(currentYear) && currentYear) {
          this._currentYear = currentYear;
          this._currentMakeId = undefined;
          this._currentModelId = undefined;
          this._currentConfigId = undefined;
          this.setOptions({ yearId: currentYear });
          this.fetchMakes();
        }
        break;
      case R.Make:
        this._currentMakeId = data.value;
        this._currentModelId = undefined;
        this._currentConfigId = undefined;
        this.setOptions({ makeId: this._currentMakeId, yearId: this._currentYear });
        this.fetchModels();
        // Needed for free-form answer flows for trailers
        this.makeDisplayValue = (_a = data.displayValue) !== null && _a !== void 0 ? _a : '';
        break;
      case R.Model:
        this._currentModelId = data.value;
        this._currentConfigId = undefined;
        this.setOptions({
          modelId: this._currentModelId,
          makeId: this._currentMakeId,
          yearId: this._currentYear,
        });
        if (!this.isVehicleTrailer) {
          this.fetchConfigurations();
        }
        break;
      case R.Configuration:
        this._currentConfigId = data.value;
        this.setOptions({
          configurationId: this._currentConfigId,
          modelId: this._currentModelId,
          makeId: this._currentMakeId,
          yearId: this._currentYear,
        });
        break;
    }
    this.vehicleLabel = this.getVehicleLabel();
    this.canSave = this.isVehicleInputComplete();
  }
  fetchYears() {
    this.loadYears({ config: this.config, questionGroupId: this.questionGroupId });
  }
  fetchMakes() {
    this.loadMakes({
      config: this.config,
      questionGroupId: this.questionGroupId,
      type: this.type,
      year: this._currentYear,
    });
  }
  fetchModels() {
    this.loadModels({
      config: this.config,
      questionGroupId: this.questionGroupId,
      type: this.type,
      year: this._currentYear,
      makeId: this._currentMakeId,
    });
  }
  fetchConfigurations() {
    this.loadConfigurations({
      config: this.config,
      questionGroupId: this.questionGroupId,
      type: this.type,
      year: this._currentYear,
      makeId: this._currentMakeId,
      modelId: this._currentModelId,
    });
  }
  onMakeDirty() {
    if (!this.isValid && !this.isEditing && this.canEdit) {
      this.onEdit();
      setTimeout(() => vx(), 200);
    }
  }
  onVinUpdate(event) {
    const answer = this.questionGroup.answers.find((ans) => ans.id === event.detail.answerId);
    if (answer != null) {
      this.saveAnswer.emit({ answer, new_value: event.detail.vin });
    }
  }
  onVehicleSave(saveEvent) {
    const flowType = saveEvent.detail;
    const isTrailerFlow = flowType === P.trailers;
    const type = isTrailerFlow ? P.trailers : undefined;
    const params = {
      answerPoolId: this.questionGroup.poolId,
      appId: this.appFormId,
      questionGroupId: this.questionGroup.groupId,
      configurationId: this._currentConfigId,
      flowType,
      config: this.config,
      type,
      callback: this.onVehicleSaveCallback,
    };
    if (flowType && (isTrailerFlow || this._currentConfigId)) {
      this.isSaving = true;
      if (isTrailerFlow && !this._currentConfigId) {
        /**
         * The vehicle params support the free-form text flow. They will be ignored if params.configurationId is defined.
         * In a free-form flow, PE uses the YMM values as-is, so we always need to pass them as the display values
         * instead of as IDs.
         *
         * The year id always matches the display value, so we can use that in any scenario.
         * If we are in a free-form flow, the model will always be a free-form answer. Therefore the id and display
         * values will match, and we can send the model id.
         * Make can be a dropdown option id or a free-form answer. If it is a dropdown option, the display value is the
         * text value we need to send to PE. If it is a free-form answer, the display value will match the id, and either
         * can be sent to PE. Therefore, we can safely choose the display value for either scenario.
         */
        params.vehicle = {
          yearId: this._currentYear,
          makeId: this.makeDisplayValue,
          modelId: this._currentModelId,
        };
      }
      this.selectVehicle(params);
    }
  }
  onVehicleResourceChange(vehicleSelectionState) {
    if (this.isEditing) {
      switch (vehicleSelectionState) {
        case s.Loaded:
          this.resetSelectedVehicle({ questionGroupId: this.questionGroup.groupId });
          break;
      }
    }
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  onEdit() {
    if (!this.yearOptions || !Object.keys(this.yearOptions).length) {
      this.fetchYears();
    }
    this.isEditing = true;
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (h("bp-sdk-external-vehicle-panel-container", { answers: this.answers, appFormId: this.appFormId, canDelete: this.canDelete, code: this.code, config: this.config, isVehicleTrailer: this.isVehicleTrailer, questionGroup: this.questionGroup, selectionStatus: this.selectionStatus, shouldShowTrailers: this.shouldShowTrailers, yearOptions: this.yearOptions, vehicleInformation: this.vehicleInformation, vehicleLabel: this.vehicleLabel }));
  }
  renderInternal() {
    return (h("bp-sdk-vehicle-panel", { answers: this.answers, canDelete: this.canDelete, canEdit: this.canEdit, canSave: this.canSave, code: this.code, handleClose: this.onClose, handleDelete: this.deleteVehicle, handleEdit: this.editVehicle, handleOpen: this.onOpen, isEditing: this.isEditing, isExpanded: this.isExpanded, isValid: this.isValid, questionGroup: this.questionGroup, isVehicleTrailer: this.isVehicleTrailer, shouldShowTrailers: this.shouldShowTrailers, vehicleInformation: this.vehicleInformation, vehicleLabel: this.vehicleLabel }));
  }
  getVehicleLabel() {
    var _a, _b, _c;
    // This is the anchor question. Its value should be the full vehicle name
    return (_c = (_b = (_a = this.questionGroup) === null || _a === void 0 ? void 0 : _a.parentQuestionAnswer) === null || _b === void 0 ? void 0 : _b.value) !== null && _c !== void 0 ? _c : '';
  }
  isVehicleInputComplete() {
    const hasTrailerValues = !!this._currentYear && !!this._currentMakeId && !!this._currentModelId;
    const canSaveTrailer = this.isVehicleTrailer && hasTrailerValues;
    return canSaveTrailer || !!this._currentConfigId;
  }
  get el() { return getElement(this); }
  static get watchers() { return {
    "tabIndex": ["onTabChanged"],
    "isVehicleTrailer": ["onIsVehicleTrailerChanged"],
    "questionGroup": ["onQuestionGroupChange"],
    "vehicleInformation": ["onVehicleInformationChange"],
    "selectionStatus": ["onVehicleResourceChange"]
  }; }
};
BpSdkVehiclePanelContainer.style = bpSdkVehiclePanelContainerCss;

const bpSdkVehiclePanelContentCss = "";

const BpSdkVehiclePanelContent = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.additionalAnswers = [];
    this.labelledBy = undefined;
    this.questionGroup = undefined;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-vehicle-panel-content');
    customElements.whenDefined('bp-sdk-external-vehicle-panel-content').then(() => {
      this.useExternal = true;
    });
  }
  shouldRenderQuestionGroup(questionGroupsWithAnswersAsKey, answer) {
    return questionGroupsWithAnswersAsKey.has(answer.id);
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (h("bp-sdk-external-vehicle-panel-content", { additionalAnswers: this.additionalAnswers, labelledBy: this.labelledBy, questionGroup: this.questionGroup }));
  }
  renderInternal() {
    return this.additionalAnswers.map((answer) => {
      return this.renderAnswer(answer);
    });
  }
  renderAnswer(answer) {
    var _a, _b;
    if (!answer) {
      return null;
    }
    const nestedGroupToRender = (_b = (_a = this.questionGroup) === null || _a === void 0 ? void 0 : _a.nestedGroupsWithAnswers) === null || _b === void 0 ? void 0 : _b.get(answer.id);
    return [
      !nestedGroupToRender && h("bp-sdk-dynamic-input-redux-container", { answer: answer }),
      nestedGroupToRender && h("bp-sdk-question-group-container", { questionGroup: nestedGroupToRender }),
    ];
  }
};
BpSdkVehiclePanelContent.style = bpSdkVehiclePanelContentCss;

const bpSdkVehiclePanelLabelCss = "";

const BpSdkVehiclePanelLabel = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.vehicleLabel = 'Add new vehicle';
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-vehicle-panel-label');
    customElements.whenDefined('bp-sdk-external-vehicle-panel-label').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return h("bp-sdk-external-vehicle-panel-label", { vehicleLabel: this.vehicleLabel });
  }
  renderInternal() {
    return (h("div", { class: "bp-sdk-vehicle-panel-label__container" }, h("span", null, this.vehicleLabel)));
  }
};
BpSdkVehiclePanelLabel.style = bpSdkVehiclePanelLabelCss;

const bpSdkVehicleSaveButtonCss = "";

const BpSdkVehicleSaveButton = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.text = '';
    this.buttonId = fx(8);
    this.buttonDisabled = false;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-vehicle-save-button');
    customElements.whenDefined('bp-sdk-external-vehicle-save-button').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return h("bp-sdk-external-vehicle-save-button", { text: this.text, buttonId: this.buttonId, buttonDisabled: this.buttonDisabled });
  }
  renderInternal() {
    return (h("bp-sdk-button", { class: "bp-sdk-vehicle-save-button__container", text: this.text, buttonId: this.buttonId, buttonDisabled: this.buttonDisabled }));
  }
};
BpSdkVehicleSaveButton.style = bpSdkVehicleSaveButtonCss;

const bpSdkVehicleVinCss = "";

const VIN = {
  min: 17,
  max: 17,
  placeholder: 'VIN',
  type: 'vin',
};
const ConfigCode = 'mqs_vehicle_submodel';
const BpSdkVehicleVin = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.answerId = undefined;
    this.code = undefined;
    this.isSearching = false;
    this.shouldSelectConfiguration = false;
    this.touched = false;
    this.pristine = true;
    this.label = undefined;
    this.errors = [];
    this.errorText = undefined;
    this.canSave = true;
    this.canSearch = true;
    this.hasResult = false;
    this.questionGroupId = undefined;
    this.value = undefined;
    this.useExternal = false;
    this.labelId = fx(8);
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-vehicle-vin');
    customElements.whenDefined('bp-sdk-external-vehicle-vin').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (h("bp-sdk-external-vehicle-vin", { answerId: this.answerId, canSave: this.canSave, canSearch: this.canSearch, code: this.code, errors: this.errors, errorText: this.errorText, hasResult: this.hasResult, isSearching: this.isSearching, label: this.label, labelId: this.labelId, questionGroupId: this.questionGroupId, pristine: this.pristine, shouldSelectConfiguration: this.shouldSelectConfiguration, touched: this.touched }));
  }
  renderInternal() {
    return (h("div", { class: "bp-sdk-vehicle-vin__container" }, h("div", { class: "bp-sdk-vehicle-vin__wrapper" }, h("bp-sdk-text-input", { answerId: this.answerId, code: this.code, errors: this.errors, errorText: this.errorText, fieldType: VIN.type, isEnabled: this.canSearch, label: this.label, labelId: this.labelId, max: VIN.max, min: VIN.min, placeholder: VIN.placeholder, pristine: this.pristine, questionId: this.labelId, touched: this.touched, text: this.value }), this.shouldSelectConfiguration && (h("bp-sdk-vehicle-configurations-container", { questionGroupId: this.questionGroupId, checkYmm: false, code: ConfigCode })))));
  }
};
BpSdkVehicleVin.style = bpSdkVehicleVinCss;

const bpSdkVehicleVinContainerCss = "";

const BpSdkVehicleVinContainer = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.vinUpdate = createEvent(this, "vinUpdate", 7);
    this.ymmcUpdate = createEvent(this, "ymmcUpdate", 7);
    this.handleSubscriptions = () => {
      if (canGetStore()) {
        this.storeUnsubscribe && this.storeUnsubscribe();
        store.mapDispatchToProps(this, { loadVin });
        this.storeUnsubscribe = store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        config: getPartnerEngineConfig(state),
        configurationOptions: getVehicleOptionsConfigurations(state, this.questionGroupId),
        vinOptions: getVehicleOptionsVin(state, this.questionGroupId),
        vinStatus: getVinSelectionState(state, this.questionGroupId),
      };
    };
    this.onFocusOut = () => {
      this.touched = true;
      this.updateErrors(this.pristine, true, this.value);
    };
    this.answerId = undefined;
    this.code = undefined;
    this.vinOptions = Object.assign({}, Ce);
    this.configurationOptions = {};
    this.vinStatus = s.NotLoaded;
    this.questionGroupId = undefined;
    this.canSave = false;
    this.value = '';
    this.config = undefined;
    this.lastResponse = undefined;
    this.canSearch = undefined;
    this.useExternal = false;
    this.touched = false;
    this.pristine = true;
    this.errorText = undefined;
    this.hasResult = false;
    this.isSearching = false;
    this.shouldSelectConfiguration = false;
    this.errors = [];
    this.vinResource = undefined;
  }
  resetState() {
    this.touched = false;
    this.pristine = true;
    this.errors = [];
    this.errorText = undefined;
  }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-vehicle-vin-container');
    customElements.whenDefined('bp-sdk-external-vehicle-vin-container').then(() => {
      this.useExternal = true;
    });
    this.onQuestionGroupIdChange();
  }
  onQuestionGroupIdChange() {
    this.handleSubscriptions();
  }
  onVinOptionsChange(vinOptions) {
    var _a;
    this.canSearch = (_a = vinOptions === null || vinOptions === void 0 ? void 0 : vinOptions.isAvailable) !== null && _a !== void 0 ? _a : true;
    this.lastResponse = vinOptions === null || vinOptions === void 0 ? void 0 : vinOptions.lastResponse;
  }
  onVinStatusChange(vinStatus) {
    this.vinResource = vinStatus !== null && vinStatus !== void 0 ? vinStatus : s.NotLoaded;
    this.isSearching = this.vinResource === s.Loading;
  }
  onConfigurationOptionsChange(configurationOptions) {
    const configs = configurationOptions !== null && configurationOptions !== void 0 ? configurationOptions : {};
    const keys = Object.keys(configs);
    this.hasResult = keys.length > 0;
    this.updateShouldSelectConfiguration(this.value, configurationOptions);
    if (keys.length === 1) {
      this.ymmcUpdate.emit({ type: R.Configuration, value: Object.keys(configurationOptions)[0] });
    }
  }
  loadFocusEvents() {
    if (!this.useExternal) {
      this.el.addEventListener('focusout', this.onFocusOut);
    }
  }
  unloadFocusEvents() {
    this.el.removeEventListener('focusout', this.onFocusOut);
  }
  componentDidLoad() {
    this.loadFocusEvents();
  }
  disconnectedCallback() {
    this.unloadFocusEvents();
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  onValueChange(value) {
    this.updateShouldSelectConfiguration(value, this.configurationOptions);
  }
  updateShouldSelectConfiguration(vin, configurations) {
    // spread operator on configurations guards against null/undefined
    this.shouldSelectConfiguration = !!vin && Object.keys(Object.assign({}, configurations)).length > 1;
  }
  setVin(vin) {
    this.pristine = false;
    this.value = vin;
    this.updateErrors(this.pristine, this.touched, vin);
    const hasErrors = this.errors.length > 0 || this.errorText;
    const hasValidLength = VehicleVinService.hasValidLength(vin);
    this.canSave = !hasErrors && hasValidLength;
    if (!hasErrors) {
      if (hasValidLength) {
        this.loadVin({
          vin,
          config: this.config,
          questionGroupId: this.questionGroupId,
        });
      }
      this.vinUpdate.emit({ vin, answerId: this.answerId });
    }
  }
  onValueUpdate({ detail }) {
    if (this.useExternal) {
      return;
    }
    const vin = detail !== null && detail !== void 0 ? detail : '';
    if (Fe(this.value, vin)) {
      this.setVin(vin);
    }
  }
  updateErrors(pristine, touched, vin) {
    this.errors = l4(pristine, touched, vin) ? ['required'] : [];
    this.errorText = VehicleVinService.getValidationErrorMessage(vin);
  }
  onMakeDirty() {
    this.touched = true;
    this.pristine = false;
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (h("bp-sdk-external-vehicle-vin-container", { answerId: this.answerId, code: this.code, canSave: this.canSave, canSearch: this.canSearch, config: this.config, configurationOptions: this.configurationOptions, questionGroupId: this.questionGroupId, value: this.value, vinOptions: this.vinOptions, vinStatus: this.vinStatus }));
  }
  renderInternal() {
    return (h("bp-sdk-vehicle-vin", { answerId: this.answerId, canSave: this.canSave, code: this.code, label: "Enter vehicle VIN", isSearching: this.isSearching, hasResult: this.hasResult, touched: this.touched, pristine: this.pristine, errors: this.errors, shouldSelectConfiguration: this.shouldSelectConfiguration, questionGroupId: this.questionGroupId, errorText: this.errorText, value: this.value }));
  }
  get el() { return getElement(this); }
  static get watchers() { return {
    "questionGroupId": ["onQuestionGroupIdChange"],
    "vinOptions": ["onVinOptionsChange"],
    "vinStatus": ["onVinStatusChange"],
    "configurationOptions": ["onConfigurationOptionsChange"],
    "value": ["onValueChange"]
  }; }
};
BpSdkVehicleVinContainer.style = bpSdkVehicleVinContainerCss;

const bpSdkVehicleYearsContainerCss = "";

const BpSdkVehicleYearsContainer = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.ymmcUpdate = createEvent(this, "ymmcUpdate", 7);
    this.handleSubscriptions = () => {
      if (canGetStore()) {
        store.mapDispatchToProps(this, {
          loadYears,
        });
        this.storeUnsubscribe && this.storeUnsubscribe();
        this.storeUnsubscribe = store.mapStateToProps(this, this.mapStateToProps);
      }
    };
    this.mapStateToProps = (state) => {
      return {
        config: getPartnerEngineConfig(state),
        yearOptions: getVehicleOptionsYears(state, this.questionGroupId),
        selectedVehicle: getVehicleOptionsSelection(state, this.questionGroupId),
      };
    };
    this.onFocusOut = () => {
      this.touched = true;
      this.updateErrors(this.pristine, true, this.value);
    };
    this.selectedVehicle = undefined;
    this.yearOptions = {};
    this.questionGroupId = undefined;
    this.isVehicleTrailer = false;
    this.config = undefined;
    this.answerId = undefined;
    this.code = undefined;
    this.choices = [];
    this.filter = undefined;
    this.filteredChoices = [];
    this.useExternal = false;
    this.touched = false;
    this.pristine = true;
    this.value = undefined;
    this.errors = [];
  }
  resetState() {
    this.touched = false;
    this.pristine = true;
    this.value = undefined;
    this.errors = [];
  }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-vehicle-years-container');
    customElements.whenDefined('bp-sdk-external-vehicle-years-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
    this.onQuestionGroupIdChange();
  }
  fetchYears() {
    this.loadYears({ config: this.config, questionGroupId: this.questionGroupId });
  }
  onQuestionGroupIdChange() {
    this.handleSubscriptions();
  }
  onYearsChange(years) {
    if (years) {
      this.choices = this.convertYearsToChoices(years);
      this.updateValue(years, this.selectedVehicle);
    }
    else {
      this.fetchYears();
      this.updateValue(undefined, undefined);
    }
  }
  onVehicleSelectionChange(selection) {
    this.updateValue(this.yearOptions, selection);
  }
  updateValue(years, selection) {
    this.value = !!(years && (selection === null || selection === void 0 ? void 0 : selection.yearId) && years[selection.yearId]) ? years[selection.yearId].toString() : undefined;
  }
  onUseExternalChange(useExternal) {
    if (!useExternal) {
      this.unloadFocusEvents();
    }
  }
  loadFocusEvents() {
    if (!this.useExternal) {
      this.el.addEventListener('focusout', this.onFocusOut);
    }
  }
  unloadFocusEvents() {
    this.el.removeEventListener('focusout', this.onFocusOut);
  }
  componentDidLoad() {
    this.loadFocusEvents();
  }
  disconnectedCallback() {
    this.unloadFocusEvents();
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  onFilterUpdate({ detail }) {
    var _a;
    this.filter = (_a = detail === null || detail === void 0 ? void 0 : detail.value) !== null && _a !== void 0 ? _a : '';
  }
  onFilterChange(filter) {
    this.updateChoices(this.choices, filter);
  }
  onChoicesChange(choices) {
    this.updateChoices(choices, this.filter);
  }
  updateChoices(choices, filter = '') {
    const regex = new RegExp(`.*${filter}.*`, 'gi');
    this.filteredChoices = choices.filter((choice) => !!choice.value.match(regex));
  }
  onValueUpdate(evt) {
    var _a;
    if (this.useExternal) {
      return;
    }
    this.pristine = false;
    const value = ((_a = evt.detail) !== null && _a !== void 0 ? _a : [])[0];
    const num = Number(value);
    const isNumber = !Number.isNaN(num);
    this.updateErrors(false, this.touched, value);
    if (this.errors.length === 0 && isNumber && Fe(value, this.value)) {
      this.value = value;
      this.ymmcUpdate.emit({ type: R.Year, value });
      this.filter = '';
    }
  }
  onValueChange(value) {
    this.updateErrors(false, this.touched, value);
  }
  updateErrors(pristine, touched, value) {
    this.errors = l4(pristine, touched, value) ? ['required'] : [];
  }
  onMakeDirty() {
    this.touched = true;
    this.pristine = false;
    this.updateErrors(false, this.touched, this.value);
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (h("bp-sdk-external-vehicle-years-container", { answerId: this.answerId, code: this.code, config: this.config, isVehicleTrailer: this.isVehicleTrailer, questionGroupId: this.questionGroupId, selectedVehicle: this.selectedVehicle, yearOptions: this.yearOptions }));
  }
  convertYearsToChoices(years) {
    const choices = [];
    for (const year of Object.keys(years)) {
      choices.push({ id: year, value: year });
    }
    choices.sort((a, b) => parseFloat(b.value) - parseFloat(a.value));
    return choices;
  }
  renderInternal() {
    var _a, _b;
    return (this.choices.length > 0 && (h("bp-sdk-vehicle-years", { answerId: this.answerId, code: this.code, errors: this.errors, isVehicleTrailer: this.isVehicleTrailer, label: "Enter vehicle year", pristine: this.pristine, selectedYear: (_b = (_a = this.selectedVehicle) === null || _a === void 0 ? void 0 : _a.yearId) === null || _b === void 0 ? void 0 : _b.toString(), touched: this.touched, years: this.filteredChoices })));
  }
  get el() { return getElement(this); }
  static get watchers() { return {
    "questionGroupId": ["onQuestionGroupIdChange"],
    "yearOptions": ["onYearsChange"],
    "selectedVehicle": ["onVehicleSelectionChange"],
    "useExternal": ["onUseExternalChange"],
    "filter": ["onFilterChange"],
    "choices": ["onChoicesChange"],
    "value": ["onValueChange"]
  }; }
};
BpSdkVehicleYearsContainer.style = bpSdkVehicleYearsContainerCss;

export { BpSdkVehicleDeleteButton as bp_sdk_vehicle_delete_button, BpSdkVehicleEditButton as bp_sdk_vehicle_edit_button, BpSdkVehicleGroup as bp_sdk_vehicle_group, BpSdkVehicleInterface as bp_sdk_vehicle_interface, BpSdkVehicleMakesContainer as bp_sdk_vehicle_makes_container, BpSdkVehicleModelsContainer as bp_sdk_vehicle_models_container, BpSdkVehiclePanel as bp_sdk_vehicle_panel, BpSdkVehiclePanelButtons as bp_sdk_vehicle_panel_buttons, BpSdkVehiclePanelContainer as bp_sdk_vehicle_panel_container, BpSdkVehiclePanelContent as bp_sdk_vehicle_panel_content, BpSdkVehiclePanelLabel as bp_sdk_vehicle_panel_label, BpSdkVehicleSaveButton as bp_sdk_vehicle_save_button, BpSdkVehicleVin as bp_sdk_vehicle_vin, BpSdkVehicleVinContainer as bp_sdk_vehicle_vin_container, BpSdkVehicleYearsContainer as bp_sdk_vehicle_years_container };
