import { IApplicationFormQuestionSet, IDriverQuestionSetContainerComponent, IErrorState, IMappedQuestionGroupAnswers } from '@boldpenguin/sdk-types';
import { Unsubscribe } from '@stencil/redux';
import { BpSdkStore } from '@boldpenguin/sdk-redux';
export declare class BpSdkDriverQuestionSetContainer implements IDriverQuestionSetContainerComponent {
  storeUnsubscribe?: Unsubscribe;
  /**
   * Error states
   */
  errors: IErrorState;
  /**
   * Question Set
   */
  questionSet: IApplicationFormQuestionSet;
  /**
   * Is application locked
   */
  locked: boolean;
  /**
   * Can save
   */
  canSave: boolean;
  /**
   * Flag used to disable button if resources for question set are not ready
   */
  areResourcesReady: boolean;
  /**
   * Save Question set function
   */
  saveHandler: (questionSet: IApplicationFormQuestionSet) => void;
  /**
   * Mapped question groups
   */
  questionGroupsWithAnswersAsKey: Map<string, IMappedQuestionGroupAnswers>;
  /**
   * Driver count limit
   */
  driverLimit: number;
  useExternal: boolean;
  el: HTMLBpSdkDriverQuestionSetContainerElement;
  resetState(): void;
  handleSubscriptions: () => void;
  connectedCallback(): void;
  componentWillLoad(): void;
  mapStateToProps: (state: BpSdkStore) => {
    errors: IErrorState;
    driverLimit: number;
  };
  disconnectedCallback(): void;
  render(): any[];
  renderExternal(): any;
  renderInternal(): any;
}
