import { EventEmitter } from '../../stencil-public-runtime';
import { Unsubscribe } from '@stencil/redux';
import { IAnswer, IDynamicInputReduxContainerComponent, IErrorState } from '@boldpenguin/sdk-types';
import { updateActiveAnswerId, updateErrors, BpSdkStore } from '@boldpenguin/sdk-redux';
export declare class BpSdkDynamicInputReduxContainer implements IDynamicInputReduxContainerComponent {
  updateActiveAnswerId: typeof updateActiveAnswerId;
  updateErrors: typeof updateErrors;
  storeUnsubscribe?: Unsubscribe;
  /**
   * Application form answer
   */
  answer: IAnswer;
  /**
   * Label to use
   */
  label: string;
  /**
   *  Labels that describe group
   */
  labelledBy: string;
  /**
   * Use alias for select
   */
  useSelectAlias: boolean;
  /**
   * Show business class selector
   */
  showBusinessClassificationSelector: boolean;
  /**
   * Should hide label
   */
  shouldHideLabel: boolean;
  /**
   * Errors injected from redux
   */
  errorState: IErrorState;
  /**
   * Active question set ID injected from redux
   */
  activeId: string;
  /**
   * Show if Answer is accumulator
   */
  isAccumulatorAnswer: boolean;
  /**
   * Callback for accumulator Error
   */
  updateAccumulatorErrors: () => void;
  /**
   * Question code to allow targeting specific inputs by code in css
   */
  code: string | undefined;
  errors: string[];
  useExternal: boolean;
  errorsUpdate: EventEmitter<string[]>;
  el: HTMLBpSdkDynamicInputReduxContainerElement;
  handleUpdateActiveAnswerId: (answerId: string) => void;
  resetState(): void;
  handleSubscriptions: () => void;
  connectedCallback(): void;
  componentWillLoad(): void;
  mapStateToProps: (state: BpSdkStore) => {
    errorState: IErrorState;
    activeId: string;
    showBusinessClassificationSelector: boolean;
  };
  disconnectedCallback(): void;
  onErrorsStateChange(errorState: IErrorState): void;
  onAnswerChange(answer: IAnswer): void;
  getErrors(answer: IAnswer, errorsState: IErrorState): void;
  render(): any[];
  renderExternal(): any;
  renderInternal(): any;
}
