import { IMaskOptions, IMaskedInputContainerComponent } from '@boldpenguin/sdk-types';
import { Unsubscribe } from '@stencil/redux';
import { BpSdkStore } from '@boldpenguin/sdk-redux';
export declare class BpSdkMaskedInputContainer implements IMaskedInputContainerComponent {
  storeUnsubscribe?: Unsubscribe;
  /**
   * Answer id
   */
  answerId: string;
  /**
   * Aria label id's that describes input for screen readers
   */
  labelId: string;
  /**
   * Error messages
   */
  errors: any[];
  /**
   * question code
   */
  code: string;
  /**
   * Error message
   */
  errorText: string;
  /**
   * Is answer in complete state
   */
  isCompleted: boolean;
  /**
   * When true, the field will be readonly. It will display only the label and value as plain text.
   */
  isReadOnly: boolean;
  /**
   * minimum value
   */
  min: number;
  /**
   * minimum date value
   */
  minDate: string;
  /**
   * maximum value
   */
  max: number;
  /**
   * maximum date value
   */
  maxDate: string;
  /**
   * Field type
   */
  fieldType: string;
  /**
   *  Labels that describe group
   */
  labelledBy: string;
  /**
   * Regex pattern to match
   */
  pattern: string;
  /**
   * Determines if input is required
   */
  required: boolean;
  /**
   * Reference type
   */
  referenceType: string;
  /**
   * Current value
   */
  value: string;
  /**
   * Placeholder to display
   */
  placeholder: string;
  /**
   * Is touched
   */
  touched: boolean;
  /**
   * Is pristine
   */
  pristine: boolean;
  /**
   * Question id
   */
  questionId: string;
  /**
   * Label to use
   */
  label: string;
  /**
   * Is Autocomplete enabled
   */
  isAutocompleteEnabled: boolean;
  /**
   * Help text
   */
  helpText: string;
  /**
   * Specifically how the question was answered (ie. "ACORD 126")
   */
  answeredBySource: string | undefined;
  canHide: boolean;
  useComplexMaskLogic: boolean;
  mask: string;
  options: IMaskOptions;
  autoComplete: string;
  useExternal: boolean;
  el: HTMLBpSdkMaskedInputContainerElement;
  resetState(): void;
  handleSubscriptions: () => void;
  connectedCallback(): void;
  componentWillLoad(): void;
  mapStateToProps: (state: BpSdkStore) => {
    isAutocompleteEnabled: boolean;
  };
  onReferenceTypeChange(referenceType: string): void;
  onCodeChange(code: string): void;
  onIsAutocompleteEnabledChange(isAutocompleteEnabled: boolean): void;
  onFieldTypeChange(fieldType: string): void;
  updateAutocomplete({ code, fieldType, referenceType, isAutocompleteEnabled, }: {
    referenceType: string;
    code: string;
    fieldType: string;
    isAutocompleteEnabled: boolean;
  }): void;
  disconnectedCallback(): void;
  render(): any[];
  renderExternal(): any;
  renderInternal(): any;
}
