import { IQuestionPoolContainerComponent, IPartnerEngineConfig, IApplicationFormQuestionSet } from '@boldpenguin/sdk-types';
import { Unsubscribe } from '@stencil/redux';
import { addQuestionPool, BpSdkStore } from '@boldpenguin/sdk-redux';
export declare class BpSdkQuestionPoolContainer implements IQuestionPoolContainerComponent {
  storeUnsubscribe?: Unsubscribe;
  addQuestionPool: typeof addQuestionPool;
  /**
   * Add button text
   */
  addText: string;
  /**
   * Question pool code
   */
  code: string;
  /**
   * Question pool description
   */
  description: string;
  /**
   * Question pool display text
   */
  displayText: string;
  /**
   * Question pool guid
   */
  guid: string;
  /**
   * Parent question pool id
   */
  parentQuestionPoolId: string | null;
  /**
   * Parent question pool reference id
   */
  parentQuestionPoolReferenceId: string | null;
  /**
   * Question pool owner id
   */
  ownerId: string;
  /**
   * Anchor question id
   */
  parentQuestionId: string;
  /**
   * Remove button text
   */
  removeText: string;
  /**
   * tenant id for question pool
   */
  tenantId: string;
  config: IPartnerEngineConfig;
  applicationId: string;
  currentQuestionSet: IApplicationFormQuestionSet;
  useExternal: boolean;
  selectParentPoolQuestion: boolean;
  el: HTMLBpSdkQuestionPoolContainerElement;
  onParentQuestionPoolSelected(event: CustomEvent): void;
  resetState(): void;
  handleSubscriptions: () => void;
  connectedCallback(): void;
  componentWillLoad(): void;
  mapStateToProps: (state: BpSdkStore) => {
    applicationId: string;
    config: IPartnerEngineConfig;
    currentQuestionSet: IApplicationFormQuestionSet;
  };
  disconnectedCallback(): void;
  handleAddItem: () => void;
  getParentAnswers(): import("@boldpenguin/sdk-types").IAnswer[];
  render(): any[];
  renderExternal(): any;
  renderAnswer(): any;
  renderInternal(): any;
}
