import { Unsubscribe } from '@stencil/redux';
import { IPartnerEngineConfig, ITakeOverContainerComponent } from '@boldpenguin/sdk-types';
import { cloneApplicationForm, BpSdkStore } from '@boldpenguin/sdk-redux';
export declare class BpSdkTakeOverContainer implements ITakeOverContainerComponent {
  storeUnsubscribe?: Unsubscribe;
  cloneApplicationForm: typeof cloneApplicationForm;
  /**
   * Is locked injected from redux
   */
  isLocked: boolean;
  /**
   * Is clocked injected from redux
   */
  isCloned: boolean;
  /**
   * Can take over injected from redux
   */
  canTakeOver: boolean;
  /**
   * Is owner injected from redux
   */
  isOwner: boolean;
  /**
   * Is application form loaded injected from redux
   */
  isFormLoaded: boolean;
  /**
   * App form ID injected from redux
   */
  appFormId: string;
  /**
   * Partner Engine config injected from redux
   */
  config: IPartnerEngineConfig;
  useExternal: boolean;
  el: HTMLBpSdkTakeOverContainerElement;
  resetState(): void;
  handleSubscriptions: () => void;
  connectedCallback(): void;
  componentWillLoad(): void;
  mapStateToProps: (state: BpSdkStore) => {
    appFormId: string;
    isLocked: boolean;
    isCloned: boolean;
    canTakeOver: boolean;
    isOwner: boolean;
    isFormLoaded: boolean;
    config: IPartnerEngineConfig;
  };
  disconnectedCallback(): void;
  takeOverHandler: () => void;
  render(): any[];
  renderExternal(): any;
  renderInternal(): any;
}
